// json2 parser
//if(!this.JSON){this.JSON={}}(function(){function f(n){return n<10?'0'+n:n}if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+f(this.getUTCMonth()+1)+'-'+f(this.getUTCDate())+'T'+f(this.getUTCHours())+':'+f(this.getUTCMinutes())+':'+f(this.getUTCSeconds())+'Z':null};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf()}}var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+string+'"'}function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key)}if(typeof rep==='function'){value=rep.call(holder,key,value)}switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null'}gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null'}v=partial.length===0?'[]':gap?'[\n'+gap+partial.join(',\n'+gap)+'\n'+mind+']':'['+partial.join(',')+']';gap=mind;return v}if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==='string'){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v)}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v)}}}}v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+mind+'}':'{'+partial.join(',')+'}';gap=mind;return v}}if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' '}}else if(typeof space==='string'){indent=space}rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}return str('',{'':value})}}if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v}else{delete value[k]}}}}return reviver.call(holder,key,value)}text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4)})}if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j}throw new SyntaxError('JSON.parse');}}}());

var callbacks = {
	refreshVCenters: function () {
		new Ajax.Request(urlConfig.getVCenters, { method: 'get',
			onComplete: function (transport) {
				displayVCenters(transport);
			}
		});
	},
	modalShowLargeSuccessIcon: function (responseObj) {
		var selector = $('update_status'),
		    checkImg = new Image();
		checkImg.src = 'images/icons/icn_check_lg.png';
		selector.innerHTML = responseObj.errorMessage;
		Element.replace($('update_status_icon'), checkImg);
	},
	modalShowLargeFailureIcon: function (responseObj) {
		var selector = $('update_status'),
		    checkImg = new Image();
		checkImg.src = 'images/icons/icn_fail_lg.png';
		selector.innerHTML = responseObj.errorMessage;
		Element.replace($('update_status_icon'), checkImg);
	},
	showPleaseWaitMsgBox: function (msgArea) {
		msgArea.update().insert({ bottom: '<div id="divMsgStarting" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.processing") + '</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("generic.pleaseWait") + '...</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'divMsgStarting\');"></div></div>' });

		if ($('btnUnregister')) {
			disableButton('btnUnregister');
		}
		if ($('btnRegister')) {
			disableButton('btnRegister');
		}
		if ($('btnModify')) {
			disableButton('btnModify');
		}

		if ($('section_modalContent_0')) {
			disableEditButtonsAndShowStartMsg('section_modalContent_0');
		}
	},


	modalShowLargeSuccessIconWithOK: function (responseObj) {

		var divStart = "<div class=\"sectionEditButtons\"";
		var divEnd = "</div>";
		var OK = "<br><button class=\"stdButton stdButtonEmphasized1\" value=\"reset\" type=\"reset\" onclick=\"cancelEditMode('section_modalContent_0'); return false;\"> <span>" + Translator.translate('generic.ok') + "</span></button></br>";
		OK = divStart + OK + divEnd;

		var selector = $('update_status'),
		    checkImg = new Image();
		checkImg.src = 'images/icons/icn_check_lg.png';
		selector.innerHTML = responseObj.errorMessage + OK;
		Element.replace($('update_status_icon'), checkImg);
	},

	modalShowLargeFailureIconWithOK: function (responseObj) {
		var divStart = "<div class=\"sectionEditButtons\"";
		var divEnd = "</div>";
		var OK = "<br><button class=\"stdButton stdButtonEmphasized1\" value=\"reset\" type=\"reset\" onclick=\"cancelEditMode('section_modalContent_0'); return false;\"> <span>" + Translator.translate('generic.ok') + "</span></button></br>";
		OK = divStart + OK + divEnd;

		var selector = $('update_status'),
		    checkImg = new Image();
		checkImg.src = 'images/icons/icn_fail_lg.png';
		selector.innerHTML = responseObj.errorMessage + OK;
		Element.replace($('update_status_icon'), checkImg);
	}

}; 

function createDomainUsernameLocalization() {
	return Translator.translate('generic.domain').toLowerCase() + Translator.translate('generic.backSlash') + Translator.translate('generic.username').toLowerCase();
}

function clearBackupSettingsVPassword(){
    $('encryptionVPassword').value = '';
}

function BackupSettingsWatermark(){
    var elmnt = $('userName'),
        _val  = elmnt.value;

    if (_val == "" || _val == Translator.translate("generic.notConfigured")) {
        elmnt.value = createDomainUsernameLocalization();
    	elmnt.observe('click', function() {
    		elmnt.value = "";
    	});
    }
}

/*
 * sets disable state all the controls in a provided element
 * set disableState to true in order to disable the controls in the element
 * set disableState to false in order to enable the controls in the element
 */
function disableControlsInElement(el,disableState) {

    if ( disableState == true || disableState == false) {
        // first disable/enable the element
        try {
            el.disabled = disableState;         
            if ( disableState == true) {
                // add disabled class if needed
                if ( !el.hasClassName('disabled')) {
                    el.addClassName('disabled');
                }
                // reset text/password fields if disabled
                if (el.type) {
                    if ( el.type == 'password' || el.type == 'text') {
                        el.value = '';
                    }
                }
            }
            else {
                // remove disabled class if needed
                if ( el.hasClassName('disabled')) {
                    el.removeClassName('disabled');
                }
            }
        }
        catch(E){}
    
        // recursively repeat for all the child nodes
        if (el.childNodes && el.childNodes.length > 0) {    
            for (var i = 0; i < el.childNodes.length; i++) {
                disableControlsInElement(el.childNodes[i],disableState);            
            }
        }
    }
}

/*
 * initialization routine for backup modal's UI elements
 */
function initBackupNowModalElements() {

    // setup watermarks 
    formUtils.setupWatermarks('frmBackupNow');

    // retrieve the elements by id
    var _useShareCheckBox = $('chkUseShare');
    var _useShareCheckBoxText = $('chkUserShareText');
    var _backupLocation = $('backupLocation').innerHTML;

    // If backup settings do not exist , disable the checkbox
    if ( _backupLocation == null || _backupLocation == ""  || _backupLocation == "Not Configured"  || _backupLocation == Translator.translate("generic.notConfigured")) {
        if (_useShareCheckBox) {
            _useShareCheckBox.disabled = true;
            _useShareCheckBox.checked = false;
            if (_useShareCheckBoxText) {
                _useShareCheckBoxText.disabled = true;
            }
        }
    }
    else { // backup settings exists , check and enable the checkbox + disable the input fields using their content element
        if (_useShareCheckBox) {
            _useShareCheckBox.disabled = false;
            _useShareCheckBox.checked = true;
            if (_useShareCheckBoxText) {
            _useShareCheckBoxText.disabled = false;
            }
            disableControlsInElement($('block_section_modalContent_0_0_0'),true);
        }
    }
        
}

/*
 * Make the JSON call to backup using share info and show the results 
 */
function backupUsingShareInfo(formId) {
    
    var form = $(formId);
    var sectionId = form.up('.containerSection').readAttribute('id');
    var msgArea = $('section_30_0_messages');
    var tmpId   = msgArea.readAttribute('id')  + '_' + (Math.floor(Math.random() * 10000));

    new Ajax.Request(urlConfig.backupNowUsingShareInfo, { method: 'post',
        onCreate:function(){
            // show busy waiting
            callbacks.showPleaseWaitMsgBox($(sectionId).down('.sectionMessages'));
        },
        onSuccess: function (transport) {
            // get the response object
            var responseObj = formHandler.pullResult(transport);
    
            // response code is success(0) => show the success message in sectionMessage area and close the modal
            if(responseObj.responseCode == 0) {
            	msgArea.update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + responseObj.errorMessage + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
                closeModal();
            } 
            else { // response code is not success => show the error message in sectionMessage area  
            	$(sectionId).down('.sectionMessages').update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + responseObj.errorMessage + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div><div style="clear:both;"></div></div>' });
                // enable the apply and cancel buttons
                enableButtons();
            }
            //reload the data for backup page
            onLoadBackupPage();
        },
        onFailure: function (transport){ // typically a NETWORK failure
            var strMsg = '';
            if(transport != null && transport.responseText != null){
                strMsg = transport.responseText;
            }
            // logout if needed
            checkForSecurityAndLogout(strMsg);
            // close modal
            closeModal();
            // show error message in the sectionMessage area
            msgArea.update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("generic.errors.networkError") + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div><div style="clear:both;"></div></div>' });
            // enable the apply and cancel buttons
            enableButtons();
            //reload the data for backup page
            onLoadBackupPage();
        }
    });
}

/*
 * handler for backup modal's submit action
 */
function backupModalSubmitHandler() {

    var _useShareCheckBox = $('chkUseShare');
    
    // if checkbox is checked, then backup using shared info
    if (_useShareCheckBox && _useShareCheckBox.checked ) {
        backupUsingShareInfo('frmBackupNow');
    }
    else {  // do the old way - backup using the form data
            formHandler.send('frmBackupNow',urlConfig.backupNow,
                        { onStart:callbacks.showPleaseWaitMsgBox,
                          closeModalOnSuccess:true,
                          onSuccess:onLoadBackupPage,
                          msgArea:'section_30_0_messages'}
            );
    }
}



function restartTabbingOrder( formID ){
    var _form   = $(formID),
        _elmnts = _form.select('input');

    if( _form != "undefined" && _elmnts.length > 0){
        _form.focusFirstElement();
    }
}

function modifyVCenterWatermark(el){
    if( el.value == "" ){
        el.value = Translator.translate('generic.domain').toLowerCase() + Translator.translate('generic.backSlash') + Translator.translate('generic.username').toLowerCase();
        el.addClassName('watermark');
    }
}

function disableButton(id){
    var btn = $(id)
    btn.disabled = true;
    btn.addClassName('stdButtonDisabled');
}

function enableButton(id){
    var btn = $(id)
    btn.disabled = false;
    btn.removeClassName('stdButtonDisabled');
}

function enableButtons(){
     
     if( $('btnRegister') ){
         enableButton('btnRegister');
         $('btnRegister').addClassName("stdButton stdButtonEmphasized1");
     }
     if( $('btnRegisterCancel') ){
         enableButton('btnRegisterCancel');
     }
     if( $('btnUnregister') ){
         enableButton('btnUnregister');
         $('btnUnregister').addClassName("stdButton stdButtonEmphasized1");
     }
     if( $('btnUnregisterCancel') ){
         enableButton('btnUnregisterCancel');
     }
     if( $('btnModify') ){
         enableButton('btnModify');
         $('btnModify').addClassName("stdButton stdButtonEmphasized1");
     }
     if( $('btnModifyCancel') ){
         enableButton('btnModifyCancel');
     }
     if( $('btnBackupNow') ){
         enableButton('btnBackupNow');
         $('btnBackupNow').addClassName("stdButton stdButtonEmphasized1");
     }
     if( $('btnRestoreNow') ){
         enableButton('btnRestoreNow');
         $('btnRestoreNow').addClassName("stdButton stdButtonEmphasized1");
     }
     if( $('btnRestoreNowCancel') ){
         enableButton('btnRestoreNowCancel');
     }
     if( $('btnBackupNowCancel') ){
         enableButton('btnBackupNowCancel');
     }
}


function resetValidateStatusDisplay(idIcon,idText){
    $(idIcon).replace('<span id="'+idIcon+'" class="status_icon"></span>');
    $(idText).replace('<span id="'+idText+'" class="msg-text"></span>');
}

function showHide(showElementID,hideElementID){
   $(hideElementID).setStyle({display:'none'});
   $(showElementID).setStyle({display:'block'});
}

function handleNtpDisplay(){
    if( $('enabled').innerHTML == 'Disabled' ){
        closeMsgBox('ntp_standard')
    }else{
        var tmpId   = 'ntp_standard';
        $('section_3_0_messages').update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.info") + '.</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("applianceManagement.vmwareToolsTimeSyncOptionDisabled") + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
    }
}


/* @NOTE displayNtpSettings() MOVED TO custom.js */

var formUtils = { } // namespace for form utility methods

/* Utility: setup watermarks fields in a form
----------------------------------------------------- */
formUtils.setupWatermarks = function (containerID) {
	var items = $(containerID).select('input');
	items.each(function (element) {
		var val = element.value;
		if (Element.readAttribute(element, 'type') == 'password') {
			//element.value = '**********';
			//element.addClassName('clearOnClick');
			//element.addClassName('watermark')
		} else if (!val) {
			element.value = Translator.translate('generic.notConfigured');
			element.addClassName('clearOnClick');
			element.addClassName('watermark');
		}
		if ($(element).hasClassName('domainWatermark')) {
			$(element).value = createDomainUsernameLocalization();
		}
	})

	$(containerID).observe('click', function (ev) {
		var clicked = ev.findElement('input');
		if (typeof (clicked) != "undefined") {
			if ($(clicked).hasClassName('clearOnClick')) {
				clicked.value = '';
				clicked.removeClassName('clearOnClick');
				clicked.removeClassName('watermark');
			}
		}
	})
}

formUtils.clearWatermarks = function(el){
    var _el = $(el);
    if(_el.hasClassName('watermark')){
        _el.value = '';
        _el.removeClassName('watermark');
        _el.removeClassName('clearOnClick');
    }
}

/* Validation stuff
----------------------------------------------------- */
formUtils.validate = function () {

	// @PRIVATE
	var errors = [],
        matches = []; // used for comparing password fields

	// @PRIVATE
	function notempty(el) {
		var _id = Element.readAttribute(el, 'id');

		var fieldName = Element.readAttribute(el, 'data-validate-display') != null ? Translator.translate(Element.readAttribute(el, 'data-validate-display')) : Element.readAttribute(el, 'name')

		var _msg = Translator.translate('generic.errors.fieldCannotBeEmpty', { FIELD_NAME: fieldName });

		if (el.value == '' || el.value == Translator.translate('generic.notConfigured') || el.value == Translator.translate('generic.notConfigured') || el.value == createDomainUsernameLocalization()) {
			errors.push({ id: _id, msg: _msg });
		}
		if (Element.readAttribute(el, 'type') == 'password' && el.value == '**********') {
			errors.push({ id: _id, msg: _msg })
		}
	}

	// @PRIVATE
	function match(el) {
		matches.push({ id: Element.readAttribute(el, 'id'), val: el.value });
	}

	// @PRIVATE
	function username(el) {
		var val = el.value,
            filter = /^[\d\w]+\/+[\d\w]/;
		//if(!filter.test(val)){
		if (val == null || val == "") {
			errors.push({ id: Element.readAttribute(el, 'id'), msg: Translator.translate('generic.errors.usernameCannotBeEmpty') });
		}
	}

	// @PUBLIC (using module pattern)
	return {
		test: function (el) {
			try {
				var methods = Element.readAttribute(el, 'data-validate').split(';');
				methods.each(function (testFor) {
					eval(testFor + '(el)');
				})
			} catch (err) { /* do nothing */ }
		},
		getErrors: function () {
			if (matches.length > 0) {
				if (matches[0].val !== matches[1].val) {
					errors.push({ id: matches[0].id, msg: Translator.translate('generic.errors.passwordFieldsDontMatch') });
				}
			}

			return errors;
		}
	}

}


var sendObjects = {

    frmNtpSettings:function(){
        var NtpSettings = Class.create({
            initialize: function () {
                this.enabled;
                this.ntpPreferred;
                this.ntpSecondary;
            }
        });
        return new NtpSettings();
    },

    frmProxySettings:function(){
        var ProxySettings = Class.create({
            initialize: function () {
                this.proxyServerStatus;
                this.proxyServerAddress;
                this.port;
                this.userName;
                this.password;
            }
        });
        return new ProxySettings();
    },

    /* @Note vCenterInfo obj. is returned by multiple calls, so lets only
     *       define it once here and then reuse
    -------------------------------------------------------- */
    vCenterInfo: Class.create({
        initialize: function () {
            this.machineId = 0;
            this.machineName;
            this.machineIp;
            this.userName;
            this.password;
            this.vPassword;
            this.csrf;
        }
    }),

    frmRegisterNewVCenter:function(){return new this.vCenterInfo();},
    frmModifyVCenter:function(){return new this.vCenterInfo();},
    frmUpdateVCenter:function(){return new this.vCenterInfo();},
    frmUnregisterVCenter:function(){return new this.vCenterInfo();},
    frmApplianceUpdate:function(){
        var ApplianceUpdateApply = Class.create({
            initialize:function(){
                this.repositoryPath;
            }
        })
        return new ApplianceUpdateApply();
    },

    frmGenerateCSR:function(){
        var GenerateCSR = Class.create({
            initialize:function(){
                this.commonName;
                this.orgName;
                this.orgUnit;
                this.locality;
                this.state;
                this.country;
                this.email;
            }
        })
        return new GenerateCSR();
    },

    frmBackupSchedule:function(){
        var BackupScheduleInfo = Class.create({
            initialize: function () {
                this.enabled = false;
                this.sunday = false;
                this.monday = false;
                this.tuesday = false;
                this.wednesday = false;
                this.thursday = false;
                this.friday = false;
                this.saturday = false;
                this.timeOfBackup = '';
                this.nextBackup = '';
                this.lastBackupDate = '';
                this.lastBackupStatus = '';
             }
        });
        return new BackupScheduleInfo();
    },

    frmBackupSettings:function(){
        var BackupSettings = Class.create({
            initialize:function(){
                this.encryptionPassword;
                this.encryptionVPassword;
                this.backupLocation;
                this.userName;
                this.backupLocationPassword;
            }
        })
        return new BackupSettings();
    },

    frmUpdateAppliance:function(){
        var UpdateVirtualAppliance = Class.create({
            initialize:function(){
                this.updateAppliance;
            }
        })
        return new UpdateVirtualAppliance();
    },

    frmBackupNow:function(){
        var BackupShareInfo = Class.create({
            initialize:function(){
                this.share;
                this.user;
                this.password;
                this.encryptionPassword;
                this.domain;
            }
        })
        return new BackupShareInfo;
    },

    frmRestore:function(){
        var BackupShareInfo = Class.create({
            initialize:function(){
                this.share;
                this.user;
                this.password;
                this.encryptionPassword;
                this.domain;
            }
        })
        return new BackupShareInfo;
    }
}


var formHandler = {
    
    /**
     * Submit all the form fields, and print out the response
     * @param form    - Form name (either "this", or the form id as a string)
     * @param url     - url to send AJAX request to
     * @param options - options for the send() function
     */
    send:function(form,url,options){
        // get all the form fields, store in an object (var data)
        var opts    = options || {},
            $form   = $(form),
            fields = $form.select('input').concat($form.select('textarea'), $form.select('select')),
            data    = {},
            validate = new formUtils.validate();

        /*
         * @IMPORTANT: here, we use the form ID to map to the correct object
         *             as defined in the sendObjects "library" (data definitions) from above
         *             ex: if the form id="frmNtpSettings", then sendData
         *             will be set to the obj. returned from sendObjects.frmNtpSettings()
         */
        var sendData = sendObjects[ $(form).readAttribute('id') ]();

        fields.each(function(el){
            validate.test(el);
            data[Element.readAttribute(el,'name')] = el.value; // used if ever migrate to JSON

            switch( Element.readAttribute(el,'type') ){
                case 'checkbox':
                    var name = Element.readAttribute(el,'name').replace(/[\[]]/,'');
                    sendData[ name ] = (el.checked ? true:false);
                    break;
                case 'radio':
                    sendData[ Element.readAttribute(el,'name') ] = (el.checked ? false:true); // radio buttons are wierd
                    break;
                case 'password':
                    sendData[ Element.readAttribute(el,'name') ] = (el.value == '**********') ? '' : el.value;
                    break;
                default:
                    sendData[ Element.readAttribute(el,'name') ] = el.value;
            }
        })

        var errors = validate.getErrors();
        
        if( errors.length > 0 ){ // client-side errors...
            enableButtons();
            var localSectionId = $form.up('.containerSection').readAttribute('id'),
                localMsgArea   = $(localSectionId).down('.sectionMessages'),
                stringList     = '<p>';
            errors.each(function(err){ // display each error
                stringList += err.msg+'<br />';
                //$(err.id).addClassName('formError');
            });
            stringList += '</p>';
            var localTmpId = localMsgArea.readAttribute('id')  + '_' + (Math.floor(Math.random() * 10000));
            localMsgArea.update().insert({bottom: '<div id="' + localTmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">'+Translator.translate('generic.failed')+'</div></td><td class="maxWidthCol"><div class="msgText">' +stringList+ '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + localTmpId + '\');"></div><div style="clear:both;"></div></div>'});
            
        }else{
            var sectionId = $form.up('.containerSection').readAttribute('id'),
            msgArea = $(opts.msgArea) || $(sectionId).down('.sectionMessages'),
            tmpId   = msgArea.readAttribute('id')  + '_' + (Math.floor(Math.random() * 10000));
            // spin when ntpStting
            if(url==urlConfig.saveNtpSettings)
            {
                  if (sendData.enabled==true && sendData.ntpPreferred!='')
                       openVirtualApplianceActionModalAndCloseSectionMessage(urlConfig.viewNTPModal, 'halfWidth');
                else if (sendData.enabled==false)
                       openVirtualApplianceActionModalAndCloseSectionMessage(urlConfig.viewNTPModal, 'halfWidth');
            }
            
            // @CSRF
            if( !$.sessionizer.isAvailable() ){
                sendData.secretKey = $('fldSecretKey').value;
            }else{
                sendData.secretKey = $.sessionizer.get('secretKey')
            }

            // send the data object via AJAX
            new Ajax.Request(url, {parameters: sendData, method: opts.method || 'post',
                onCreate:function(){
                    (typeof opts.onStart == 'function') ? opts.onStart( $(sectionId).down('.sectionMessages') ) : eval(opts.onStart);
                },
                
                onSuccess: function (transport) {
                    var responseObj = formHandler.pullResult(transport);

                    // show the response message in sectionMessage area
                    if(responseObj.responseCode == 0){
                        if(!opts.cancelDefaultMessage && url!=urlConfig.saveNtpSettings){
                        	msgArea.update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + responseObj.errorMessage + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
                        }
                        // if onsuccess is an inline function, run it, else if its a function name
                        // passed as a string (ie. 'callbacks.refreshVCenters()', eval() it
                        (typeof opts.onSuccess == 'function') ? opts.onSuccess(responseObj) : eval(opts.onSuccess);

                        // option: close modal
                        if(opts.closeModalOnSuccess && !errors.length > 0){closeModal();}
                        
                        if (url==urlConfig.saveNtpSettings){
                            cancelEditMode('section_3_0');       
                            new Ajax.Request(urlConfig.getNtpSettings, {method: 'get',
                                    onComplete: function (transport) {
                                       // if (sendData.enabled==true && sendData.ntpPreferred!='')
                                              closeModal();
                                    displayNtpSettings(transport, true);
                                    }
                                });
                        }
                        
                        if(typeof opts.onSuccessHandler != "undefined"){
                        	opts.onSuccessHandler();
                        }
                    }else{
                        if(!opts.cancelDefaultMessage){
                        	$(sectionId).down('.sectionMessages').update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + responseObj.errorMessage + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div><div style="clear:both;"></div></div>' });
                        }
                        (typeof opts.onError == 'function') ? opts.onError(responseObj) : eval(opts.onError);
                        if (url==urlConfig.saveNtpSettings)
                        {
                            closeModal();
                            toggleSectionEditMode(sectionId);
                        }
                        enableButtons();
                    }
                    
                    if (url==urlConfig.saveNtpSettings){
                    	refreshNTPSettings();
                    }
                },
                onFailure: function (transport){ // this is a NETWORK failure
                    var strMsg = '';
                    if(transport != null && transport.responseText != null){
                        strMsg = transport.responseText;
                    }
                    checkForSecurityAndLogout(strMsg);
                    if(!opts.cancelDefaultMessage){
                    	msgArea.update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate('generic.errors.networkError') + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div><div style="clear:both;"></div></div>' });
                    }
                    // option: close modal
                    if(opts.closeModalOnFailure){closeModal();}

                    toggleSectionEditMode(sectionId);
                    enableButtons();
                }
            });
        }

        // option: close modal absolutely
        if(opts.closeModal && !errors.length > 0){closeModal();}
    },

    // utility function to abstract the response to a common object
    pullResult:function(transport){
        var parsedJSON = transport.responseText.evalJSON(true);
        for(var responseObject in parsedJSON) break; // get the common response object, ignore the rspns object name
        return parsedJSON[responseObject];
    }
}



/* Ip Field auto-tabbing, restrict to number entry
----------------------------------------------------- */
formUtils.ipFields = {

    fieldId:null,
    spanToInput:function(item){
        var value = (item.innerHTML.strip() != '') ? item.innerHTML.strip() : '',
            flds  = (value != '') ? value.split('.') : ['','','',''],
            str = '';
        formUtils.ipFields.fieldId = $(item).readAttribute('id');
        for( i=0; i<flds.length; i++ ){
            str += '<input name="ipField_'+i+'" id="ipField_'+i+'" maxlength="3" type="text" class="inputFldIpAddress" value="'+flds[i]+'" onkeydown="formUtils.ipFields.tabToNextField(event,'+i+')" onkeypress="return formUtils.ipFields.isNumberKey(event)" />';
        }
        item.replace(str);
    },

    ipFullString:'', fldCount:1,
    inputToSpan:function(item){
        this.ipFullString += item.value+'.';
        if(this.fldCount == 4){
            $('ipAddressWrapper').innerHTML = '<span id="'+this.fieldId+'" class="inputFldIpAddress">'+(this.ipFullString).slice(0,-1)+'</span>';
            this.fldCount = 1;this.ipFullString = '';
        }else{
            this.fldCount++;
        }
    },
    
    tabToNextField:function(ev,index){
        index++;
        var keyCode = (ev.which) ? ev.which : ev.keyCode;
        if(index <= 3){
            if(keyCode == 190){$('ipField_'+index).focus()}
        }
    },

    isNumberKey:function(ev){
        var keyCode = (ev.which) ? ev.which : ev.keyCode;
        if (keyCode > 31 && (keyCode < 48 || keyCode > 57)){return false;}return true;
    },

    consolidateFields:function(){
        var address = $('ipField_0').value+'.'+$('ipField_1').value+'.'+$('ipField_2').value+'.'+$('ipField_3').value;
        $('ipAddressWrapper').insert({bottom:'<input id="_ipAddress" name="'+formUtils.ipFields.fieldId+'" type="hidden" value="'+address+'" />'});
    }
    
}


function spanToTimeScroller(item){
    if(item){
        
    }
}













/**
 * http://github.com/valums/file-uploader
 *
 * Multiple file upload component with progress-bar, drag-and-drop.
 * © 2010 Andrew Valums ( andrew(at)valums.com )
 *
 * Licensed under GNU GPL 2 or later, see license.txt.
 */

//
// Helper functions
//

var qq = qq || {};

/**
 * Adds all missing properties from second obj to first obj
 */
qq.extend = function(first, second){
    for (var prop in second){
        first[prop] = second[prop];
    }
};

/**
 * Searches for a given element in the array, returns -1 if it is not present.
 * @param {Number} [from] The index at which to begin the search
 */
qq.indexOf = function(arr, elt, from){
    if (arr.indexOf) return arr.indexOf(elt, from);

    from = from || 0;
    var len = arr.length;

    if (from < 0) from += len;

    for (; from < len; from++){
        if (from in arr && arr[from] === elt){
            return from;
        }
    }
    return -1;
};

qq.getUniqueId = (function(){
    var id = 0;
    return function(){return id++;};
})();

//
// Events

qq.attach = function(element, type, fn){
    if (element.addEventListener){
        element.addEventListener(type, fn, false);
    } else if (element.attachEvent){
        element.attachEvent('on' + type, fn);
    }
};
qq.detach = function(element, type, fn){
    if (element.removeEventListener){
        element.removeEventListener(type, fn, false);
    } else if (element.attachEvent){
        element.detachEvent('on' + type, fn);
    }
};

qq.preventDefault = function(e){
    if (e.preventDefault){
        e.preventDefault();
    } else{
        e.returnValue = false;
    }
};

//
// Node manipulations

/**
 * Insert node a before node b.
 */
qq.insertBefore = function(a, b){
    b.parentNode.insertBefore(a, b);
};
qq.remove = function(element){
    element.parentNode.removeChild(element);
};

qq.contains = function(parent, descendant){
    // compareposition returns false in this case
    if (parent == descendant) return true;

    if (parent.contains){
        return parent.contains(descendant);
    } else {
        return !!(descendant.compareDocumentPosition(parent) & 8);
    }
};

/**
 * Creates and returns element from html string
 * Uses innerHTML to create an element
 */
qq.toElement = (function(){
    var div = document.createElement('div');
    return function(html){
        div.innerHTML = html;
        var element = div.firstChild;
        div.removeChild(element);
        return element;
    };
})();

//
// Node properties and attributes

/**
 * Sets styles for an element.
 * Fixes opacity in IE6-8.
 */
qq.css = function(element, styles){
    if (styles.opacity != null){
        if (typeof element.style.opacity != 'string' && typeof(element.filters) != 'undefined'){
            styles.filter = 'alpha(opacity=' + Math.round(100 * styles.opacity) + ')';
        }
    }
    qq.extend(element.style, styles);
};
qq.hasClass = function(element, name){
    var re = new RegExp('(^| )' + name + '( |$)');
    return re.test(element.className);
};
qq.addClass = function(element, name){
    if (!qq.hasClass(element, name)){
        element.className += ' ' + name;
    }
};
qq.removeClass = function(element, name){
    var re = new RegExp('(^| )' + name + '( |$)');
    element.className = element.className.replace(re, ' ').replace(/^\s+|\s+$/g, "");
};
qq.setText = function(element, text){
    element.innerText = text;
    element.textContent = text;
};

//
// Selecting elements

qq.children = function(element){
    var children = [],
    child = element.firstChild;

    while (child){
        if (child.nodeType == 1){
            children.push(child);
        }
        child = child.nextSibling;
    }

    return children;
};

qq.getByClass = function(element, className){
    if (element.querySelectorAll){
        return element.querySelectorAll('.' + className);
    }

    var result = [];
    var candidates = element.getElementsByTagName("*");
    var len = candidates.length;

    for (var i = 0; i < len; i++){
        if (qq.hasClass(candidates[i], className)){
            result.push(candidates[i]);
        }
    }
    return result;
};

/**
 * obj2url() takes a json-object as argument and generates
 * a querystring. pretty much like jQuery.param()
 *
 * how to use:
 *
 *    `qq.obj2url({a:'b',c:'d'},'http://any.url/upload?otherParam=value');`
 *
 * will result in:
 *
 *    `http://any.url/upload?otherParam=value&a=b&c=d`
 *
 * @param  Object JSON-Object
 * @param  String current querystring-part
 * @return String encoded querystring
 */
qq.obj2url = function(obj, temp, prefixDone){
    var uristrings = [],
        prefix = '&',
        add = function(nextObj, i){
            var nextTemp = temp
                ? (/\[\]$/.test(temp)) // prevent double-encoding
                   ? temp
                   : temp+'['+i+']'
                : i;
            if ((nextTemp != 'undefined') && (i != 'undefined')) {
                uristrings.push(
                    (typeof nextObj === 'object')
                        ? qq.obj2url(nextObj, nextTemp, true)
                        : (Object.prototype.toString.call(nextObj) === '[object Function]')
                            ? encodeURIComponent(nextTemp) + '=' + encodeURIComponent(nextObj())
                            : encodeURIComponent(nextTemp) + '=' + encodeURIComponent(nextObj)
                );
            }
        };

    if (!prefixDone && temp) {
      prefix = (/\?/.test(temp)) ? (/\?$/.test(temp)) ? '' : '&' : '?';
      uristrings.push(temp);
      uristrings.push(qq.obj2url(obj));
    } else if ((Object.prototype.toString.call(obj) === '[object Array]') && (typeof obj != 'undefined') ) {
        // we wont use a for-in-loop on an array (performance)
        for (var i = 0, len = obj.length; i < len; ++i){
            add(obj[i], i);
        }
    } else if ((typeof obj != 'undefined') && (obj !== null) && (typeof obj === "object")){
        // for anything else but a scalar, we will use for-in-loop
        for (var i in obj){
            add(obj[i], i);
        }
    } else {
        uristrings.push(encodeURIComponent(temp) + '=' + encodeURIComponent(obj));
    }

    return uristrings.join(prefix)
                     .replace(/^&/, '')
                     .replace(/%20/g, '+');
};

//
//
// Uploader Classes
//
//

var qq = qq || {};

/**
 * Creates upload button, validates upload, but doesn't create file list or dd.
 */
qq.FileUploaderBasic = function (o) {
    this._options = {
        // set to true to see the server response
        debug: false,
        action: '/server/upload',
        params: {},
        button: null,
        browseButton: null,
        multiple: true,
        maxConnections: 3,
        // validation
        allowedExtensions: [],
        sizeLimit: 0,
        minSizeLimit: 0,
        // events
        // return false to cancel submit
        onSubmit: function (id, fileName) { },
        onProgress: function (id, fileName, loaded, total) { },
        onComplete: function (id, fileName, responseJSON) { },
        onCancel: function (id, fileName) { },
        // messages
        messages: {
            typeError: Translator.translate("fileUpload.messages.typeError", {FILE_NAME: "{file}", EXTENSIONS: "{extensions}"}), //"{file} has invalid extension. Only {extensions} are allowed.",
            sizeError: Translator.translate("fileUpload.messages.sizeError", { FILE_NAME: "{file}", SIZE_LIMIT: "{sizeLimit}" }), //"{file} is too large, maximum file size is {sizeLimit}.",
            minSizeError: Translator.translate("fileUpload.messages.minSizeError", { FILE_NAME: "{file}", MIN_SIZE_LIMIT: "{minSizeLimit}" }), //"{file} is too small, minimum file size is {minSizeLimit}.",
            emptyError: Translator.translate("fileUpload.messages.emptyError", { FILE_NAME: "{file}" }), //"{file} is empty, please select files again without it.",
            onLeave: Translator.translate("fileUpload.messages.leaveWarning") //"The files are being uploaded, if you leave now the upload will be cancelled."
        },
        showMessage: function (message) {
            alert(message);
        }
    };
    qq.extend(this._options, o);

    // number of files being uploaded
    this._filesInProgress = 0;
    this._handler = this._createUploadHandler();

    if (this._options.button) {
        // upload button
        this._button = this._createUploadButton(this._options.button);
        // browse button
        this._browseButton = this._createBrowseButton(this._options.browseButton);
    }

    // current file to upload
    this._currentFile = null;
    // current params
    this._currentParams = null;
    // current filename
    this._currentFilename = null;

    this._preventLeaveInProgress();
};

qq.FileUploaderBasic.prototype = {
    setParams: function (params) {
        this._options.params = params;
    },
    getInProgress: function () {
        return this._filesInProgress;
    },
    _createUploadButton: function (element) {
        var self = this;

        return new qq.UploadButton({
            element: element,
            multiple: this._options.multiple && qq.UploadHandlerXhr.isSupported(),
            onChange: function (input) {
                self._onInputChange(input);
            }
        });
    },
    _createBrowseButton: function (element) {
        var self = this;

        return new qq.BrowseButton({
            element: element,
            multiple: this._options.multiple && qq.UploadHandlerXhr.isSupported(),
            onChange: function (input) {
                self._onBrowseInputChange(input);
            }
        });
    },
    _createUploadHandler: function () {
        var self = this,
            handlerClass;

        if (qq.UploadHandlerXhr.isSupported()) {
            handlerClass = 'UploadHandlerXhr';
        } else {
            handlerClass = 'UploadHandlerForm';
        }

        var handler = new qq[handlerClass]({
            debug: this._options.debug,
            action: this._options.action,
            maxConnections: this._options.maxConnections,
            onProgress: function (id, fileName, loaded, total) {
                self._onProgress(id, fileName, loaded, total);
                self._options.onProgress(id, fileName, loaded, total);
            },
            onComplete: function (id, fileName, result) {
                self._onComplete(id, fileName, result);
                self._options.onComplete(id, fileName, result);
            },
            onCancel: function (id, fileName) {
                self._onCancel(id, fileName);
                self._options.onCancel(id, fileName);
            }
        });

        return handler;
    },
    _preventLeaveInProgress: function () {
        var self = this;

        qq.attach(window, 'beforeunload', function (e) {
            if (!self._filesInProgress) {return;}

            var e = e || window.event;
            // for ie, ff
            e.returnValue = self._options.messages.onLeave;
            // for webkit
            return self._options.messages.onLeave;
        });
    },
    _onSubmit: function (id, fileName) {
        this._filesInProgress++;
    },
    _onProgress: function (id, fileName, loaded, total) {
    },
    _onComplete: function (id, fileName, result) {
        this._filesInProgress--;
        if (!result.success) {
            this._options.showMessage(result.error);
        }
    },
    _onCancel: function (id, fileName) {
        this._filesInProgress--;
    },
    _onInputChange: function (input) {
        this._uploadFile(input);
        this._button.reset();
    },
    _onBrowseInputChange: function (input) {

        if (this._handler instanceof qq.UploadHandlerXhr) {
            this._addForUploadFileList(input.files);
        } else {
            if (this._validateFile(input)) {
                this._addForUploadFile(input);
            }
        }
        this._browseButton.reset();
    },
    _uploadFile: function (fileContainer) {
        if (this._currentFile != null) {
            var id = this._currentFile;
            var params = this._currentParams;
            var fileName = this._currentFilename;
            this._onSubmit(id, fileName);
            this._handler.upload(id, params);
        }
        this._currentFile = null;
        this._currentParams = null;
        this._currentFilename = null;
    },
    _addForUploadFileList: function (files) {
        for (var i = 0; i < files.length; i++) {
            if (!this._addForUploadFile(files[i])) {
                return;
            }
        }

        for (var i = 0; i < files.length; i++) {
            this._addForUploadFile(files[i]);
        }
    },
    _addForUploadFile: function (fileContainer) {
        var id = this._handler.add(fileContainer);
        var fileName = this._handler.getName(id);

        if (this._options.onSubmit(id, fileName) !== false) {
            this._currentFile = id;
            var copy = {};
            qq.extend(copy, this._options.params);
            this._currentParams = copy;
            this._currentFilename = fileName;
            this._button._enable();
        }
    },
    _validateFile: function (file) {
        var name, size;

        if (file.value) {
            // it is a file input
            // get input value and remove path to normalize
            name = file.value.replace(/.*(\/|\\)/, "");
        } else {
            // fix missing properties in Safari
            name = file.fileName != null ? file.fileName : file.name;
            size = file.fileSize != null ? file.fileSize : file.size;
        }

        if (!this._isAllowedExtension(name)) {
            this._error('typeError', name);
            return false;

        } else if (size === 0) {
            this._error('emptyError', name);
            return false;

        } else if (size && this._options.sizeLimit && size > this._options.sizeLimit) {
            this._error('sizeError', name);
            return false;

        } else if (size && size < this._options.minSizeLimit) {
            this._error('minSizeError', name);
            return false;
        }

        return true;
    },
    _error: function (code, fileName) {
        var message = this._options.messages[code];
        function r(name, replacement) {message = message.replace(name, replacement);}

        r('{file}', this._formatFileName(fileName));
        r('{extensions}', this._options.allowedExtensions.join(', '));
        r('{sizeLimit}', this._formatSize(this._options.sizeLimit));
        r('{minSizeLimit}', this._formatSize(this._options.minSizeLimit));

        this._options.showMessage(message);
    },
    _formatFileName: function (name) {
        if (name.length > 33) {
            name = name.slice(0, 19) + '...' + name.slice(-13);
        }
        return name;
    },
    _isAllowedExtension: function (fileName) {
        var ext = (-1 !== fileName.indexOf('.')) ? fileName.replace(/.*[.]/, '').toLowerCase() : '';
        var allowed = this._options.allowedExtensions;

        if (!allowed.length) {return true;}

        for (var i = 0; i < allowed.length; i++) {
            if (allowed[i].toLowerCase() == ext) {return true;}
        }

        return false;
    },
    _formatSize: function (bytes) {
        var i = -1;
        do {
            bytes = bytes / 1024;
            i++;
        } while (bytes > 99);

        return Math.max(bytes, 0.1).toFixed(1) + ['kB', 'MB', 'GB', 'TB', 'PB', 'EB'][i];
    }
};


/**
 * Class that creates upload widget with drag-and-drop and file list
 * @inherits qq.FileUploaderBasic
 */
qq.FileUploader = function(o){
    // call parent constructor
    qq.FileUploaderBasic.apply(this, arguments);

    // additional options
    qq.extend(this._options, {
        element: null,
        // if set, will be used instead of qq-upload-list in template
        listElement: null,

        template: '<div class="qq-uploader">' +
                '<div class="qq-upload-drop-area"><span>'+Translator.translate("fileUpload.messages.dropFilesInstructions")+'</span></div>' +
                '<div class="qq-browse-button">' + Translator.translate("generic.browse") + '</div>' +
                '<span> </span>' +
                '<div class="qq-upload-button">' + Translator.translate("generic.upload") + '</div>' +
                '<ul class="qq-upload-list"></ul>' +
             '</div>',

        // template for one item in file list
        fileTemplate: '<li>' +
                '<span class="qq-upload-file"></span>' +
                '<span class="qq-upload-spinner"></span>' +
                '<span class="qq-upload-size"></span>' +
                '<a class="qq-upload-cancel" href="#">' + Translator.translate("generic.cancel") + '</a>' +
                '<span class="qq-upload-failed-text">' + Translator.translate("generic.failed") + '</span>' +
            '</li>',

        classes: {
            // used to get elements from templates
            button: 'qq-upload-button',
            browseButton: 'qq-browse-button',
            drop: 'qq-upload-drop-area',
            dropActive: 'qq-upload-drop-area-active',
            list: 'qq-upload-list',

            file: 'qq-upload-file',
            spinner: 'qq-upload-spinner',
            size: 'qq-upload-size',
            cancel: 'qq-upload-cancel',

            // added to list item when upload completes
            // used in css to hide progress spinner
            success: 'qq-upload-success',
            fail: 'qq-upload-fail'
        }
    });
    // overwrite options with user supplied
    qq.extend(this._options, o);

    this._element = this._options.element;
    this._element.innerHTML = this._options.template;
    this._listElement = this._options.listElement || this._find(this._element, 'list');

    this._classes = this._options.classes;

    this._button = this._createUploadButton(this._find(this._element, 'button'));
    this._browseButton = this._createBrowseButton(this._find(this._element, 'browseButton'));

    this._bindCancelEvent();
    this._setupDragDrop();
};

// inherit from Basic Uploader
qq.extend(qq.FileUploader.prototype, qq.FileUploaderBasic.prototype);

qq.extend(qq.FileUploader.prototype, {
    /**
     * Gets one of the elements listed in this._options.classes
     **/
    _find: function(parent, type){
        var element = qq.getByClass(parent, this._options.classes[type])[0];
        if (!element){
            throw new Error('element not found ' + type);
        }

        return element;
    },
    _setupDragDrop: function(){
        var self = this,
            dropArea = this._find(this._element, 'drop');

        var dz = new qq.UploadDropZone({
            element: dropArea,
            onEnter: function(e){
                qq.addClass(dropArea, self._classes.dropActive);
                e.stopPropagation();
            },
            onLeave: function(e){
                e.stopPropagation();
            },
            onLeaveNotDescendants: function(e){
                qq.removeClass(dropArea, self._classes.dropActive);
            },
            onDrop: function(e){
                dropArea.style.display = 'none';
                qq.removeClass(dropArea, self._classes.dropActive);
                self._uploadFileList(e.dataTransfer.files);
            }
        });

        dropArea.style.display = 'none';

        qq.attach(document, 'dragenter', function(e){
            if (!dz._isValidFileDrag(e)) return;

            dropArea.style.display = 'block';
        });
        qq.attach(document, 'dragleave', function(e){
            if (!dz._isValidFileDrag(e)) return;

            var relatedTarget = document.elementFromPoint(e.clientX, e.clientY);
            // only fire when leaving document out
            if ( ! relatedTarget || relatedTarget.nodeName == "HTML"){
                dropArea.style.display = 'none';
            }
        });
    },
    _onSubmit: function(id, fileName){
        qq.FileUploaderBasic.prototype._onSubmit.apply(this, arguments);
        this._addToList(id, fileName);
    },
    _onProgress: function(id, fileName, loaded, total){
        qq.FileUploaderBasic.prototype._onProgress.apply(this, arguments);

        var item = this._getItemByFileId(id);
        var size = this._find(item, 'size');
        size.style.display = 'inline';

        var text;
        if (loaded != total){
            text = Math.round(loaded / total * 100) + '% from ' + this._formatSize(total);
        } else {
            text = this._formatSize(total);
        }

        qq.setText(size, text);
    },
    _onComplete: function(id, fileName, result){
        qq.FileUploaderBasic.prototype._onComplete.apply(this, arguments);

        // mark completed
        var item = this._getItemByFileId(id);
        qq.remove(this._find(item, 'cancel'));
        qq.remove(this._find(item, 'spinner'));

        if (result.success){
            qq.addClass(item, this._classes.success);
        } else {
            qq.addClass(item, this._classes.fail);
        }
    },
    _addToList: function(id, fileName){
        var item = qq.toElement(this._options.fileTemplate);
        item.qqFileId = id;

        var fileElement = this._find(item, 'file');
        qq.setText(fileElement, this._formatFileName(fileName));
        this._find(item, 'size').style.display = 'none';

        this._listElement.appendChild(item);
    },
    _getItemByFileId: function(id){
        var item = this._listElement.firstChild;

        // there can't be txt nodes in dynamically created list
        // and we can  use nextSibling
        while (item){
            if (item.qqFileId == id) return item;
            item = item.nextSibling;
        }
    },
    /**
     * delegate click event for cancel link
     **/
    _bindCancelEvent: function(){
        var self = this,
            list = this._listElement;

        qq.attach(list, 'click', function(e){
            e = e || window.event;
            var target = e.target || e.srcElement;

            if (qq.hasClass(target, self._classes.cancel)){
                qq.preventDefault(e);

                var item = target.parentNode;
                self._handler.cancel(item.qqFileId);
                qq.remove(item);
            }
        });
    }
});

qq.UploadDropZone = function(o){
    this._options = {
        element: null,
        onEnter: function(e){},
        onLeave: function(e){},
        // is not fired when leaving element by hovering descendants
        onLeaveNotDescendants: function(e){},
        onDrop: function(e){}
    };
    qq.extend(this._options, o);

    this._element = this._options.element;

    this._disableDropOutside();
    this._attachEvents();
};

qq.UploadDropZone.prototype = {
    _disableDropOutside: function(e){
        // run only once for all instances
        if (!qq.UploadDropZone.dropOutsideDisabled ){

            qq.attach(document, 'dragover', function(e){
                if (e.dataTransfer){
                    e.dataTransfer.dropEffect = 'none';
                    e.preventDefault();
                }
            });

            qq.UploadDropZone.dropOutsideDisabled = true;
        }
    },
    _attachEvents: function(){
        var self = this;

        qq.attach(self._element, 'dragover', function(e){
            if (!self._isValidFileDrag(e)) return;

            var effect = e.dataTransfer.effectAllowed;
            if (effect == 'move' || effect == 'linkMove'){
                e.dataTransfer.dropEffect = 'move'; // for FF (only move allowed)
            } else {
                e.dataTransfer.dropEffect = 'copy'; // for Chrome
            }

            e.stopPropagation();
            e.preventDefault();
        });

        qq.attach(self._element, 'dragenter', function(e){
            if (!self._isValidFileDrag(e)) return;

            self._options.onEnter(e);
        });

        qq.attach(self._element, 'dragleave', function(e){
            if (!self._isValidFileDrag(e)) return;

            self._options.onLeave(e);

            var relatedTarget = document.elementFromPoint(e.clientX, e.clientY);
            // do not fire when moving a mouse over a descendant
            if (qq.contains(this, relatedTarget)) return;

            self._options.onLeaveNotDescendants(e);
        });

        qq.attach(self._element, 'drop', function(e){
            if (!self._isValidFileDrag(e)) return;

            e.preventDefault();
            self._options.onDrop(e);
        });
    },
    _isValidFileDrag: function(e){
        var dt = e.dataTransfer,
            // do not check dt.types.contains in webkit, because it crashes safari 4
            isWebkit = navigator.userAgent.indexOf("AppleWebKit") > -1;

        // dt.effectAllowed is none in Safari 5
        // dt.types.contains check is for firefox
        return dt && dt.effectAllowed != 'none' &&
            (dt.files || (!isWebkit && dt.types.contains && dt.types.contains('Files')));

    }
};

qq.UploadButton = function(o){
    this._options = {
        element: null,
        // if set to true adds multiple attribute to file input
        multiple: false,
        // name attribute of file input
        name: 'file',
        onChange: function(input){},
        hoverClass: 'qq-upload-button-hover',
        focusClass: 'qq-upload-button-focus',
        disabledClass: 'qq-upload-button-disabled'
    };

    qq.extend(this._options, o);

    this._element = this._options.element;

    // make button suitable container for input
    qq.css(this._element, {
        position: 'relative',
        overflow: 'hidden',
        // Make sure browse button is in the right side
        // in Internet Explorer
        direction: 'ltr'
    });

    this._input = this._createInput();
};

qq.UploadButton.prototype = {
    /* returns file input element */
    getInput: function () {
        return this._input;
    },
    /* cleans/recreates the file input */
    reset: function () {
        if (this._input.parentNode) {
            qq.remove(this._input);
        }

        qq.removeClass(this._element, this._options.focusClass);
        this._input = this._createInput();
    },
    _createInput: function () {
        var input = document.createElement("input");

        if (this._options.multiple) {
            input.setAttribute("multiple", "multiple");
        }

        input.setAttribute("type", "button");
        input.setAttribute("name", this._options.name);

        qq.css(input, {
            position: 'absolute',
            // in Opera only 'browse' button
            // is clickable and it is located at
            // the right side of the input
            right: 0,
            top: 0,
            /*fontFamily: 'Arial',*/
            width: '100%',
            height: '100%',
            // 4 persons reported this, the max values that worked for them were 243, 236, 236, 118
            fontSize: '118px',
            margin: 0,
            padding: 0,
            cursor: 'pointer',
            opacity: 0
        });

        this._element.appendChild(input);

        //disable button
        $(input).setAttribute("disabled", "disabled");
        qq.addClass(this._element, this._options.disabledClass);
        $(input).setStyle({
            cursor: "default"
        });

        var self = this;
        qq.attach(input, 'click', function () {
            self._options.onChange(input);
        });

        qq.attach(input, 'mouseover', function () {
            qq.addClass(self._element, self._options.hoverClass);
        });
        qq.attach(input, 'mouseout', function () {
            qq.removeClass(self._element, self._options.hoverClass);
        });
        qq.attach(input, 'focus', function () {
            qq.addClass(self._element, self._options.focusClass);
        });
        qq.attach(input, 'blur', function () {
            qq.removeClass(self._element, self._options.focusClass);
        });

        // IE and Opera, unfortunately have 2 tab stops on file input
        // which is unacceptable in our case, disable keyboard access
        if (window.attachEvent) {
            // it is IE or Opera
            input.setAttribute('tabIndex', "-1");
        }

        return input;
    },
    _disable: function () {
        $(input).setAttribute("disabled", "disabled");
        qq.addClass(this._element, this._options.disabledClass);
        $(input).setStyle({
            cursor: "default"
        });
    },
    _enable: function () {
        $(this._input).removeAttribute('disabled');
        qq.removeClass(this._element, this._options.disabledClass);
        $(this._input).setStyle({
            cursor: "pointer"
        });
    }
};


qq.BrowseButton = function (o) {
    this._options = {
        element: null,
        // if set to true adds multiple attribute to file input
        multiple: false,
        // name attribute of file input
        name: 'browsefile',
        onChange: function (input) { },
        hoverClass: 'qq-upload-button-hover',
        focusClass: 'qq-upload-button-focus'
    };

    qq.extend(this._options, o);

    this._element = this._options.element;

    // make button suitable container for input
    qq.css(this._element, {
        position: 'relative',
        overflow: 'hidden',
        // Make sure browse button is in the right side
        // in Internet Explorer
        direction: 'ltr'
    });

    this._input = this._createInput();
};

qq.BrowseButton.prototype = {
    /* returns file input element */
    getInput: function () {
        return this._input;
    },
    /* cleans/recreates the file input */
    reset: function () {
        if (this._input.parentNode) {
            qq.remove(this._input);
        }

        qq.removeClass(this._element, this._options.focusClass);
        this._input = this._createInput();
    },
    _createInput: function () {
        var input = document.createElement("input");

        if (this._options.multiple) {
            input.setAttribute("multiple", "multiple");
        }

        input.setAttribute("type", "file");
        input.setAttribute("name", this._options.name);

        qq.css(input, {
            position: 'absolute',
            // in Opera only 'browse' button
            // is clickable and it is located at
            // the right side of the input
            right: 0,
            top: 0,
            /*fontFamily: 'Arial',*/
            // 4 persons reported this, the max values that worked for them were 243, 236, 236, 118
            fontSize: '118px',
            margin: 0,
            padding: 0,
            cursor: 'pointer',
            opacity: 0
        });

        this._element.appendChild(input);

        var self = this;
        qq.attach(input, 'change', function () {
            self._options.onChange(input);
        });

        qq.attach(input, 'mouseover', function () {
            qq.addClass(self._element, self._options.hoverClass);
        });
        qq.attach(input, 'mouseout', function () {
            qq.removeClass(self._element, self._options.hoverClass);
        });
        qq.attach(input, 'focus', function () {
            qq.addClass(self._element, self._options.focusClass);
        });
        qq.attach(input, 'blur', function () {
            qq.removeClass(self._element, self._options.focusClass);
        });

        // IE and Opera, unfortunately have 2 tab stops on file input
        // which is unacceptable in our case, disable keyboard access
        if (window.attachEvent) {
            // it is IE or Opera
            input.setAttribute('tabIndex', "-1");
        }

        return input;
    }
};

/**
 * Class for uploading files, uploading itself is handled by child classes
 */
qq.UploadHandlerAbstract = function(o){
    this._options = {
        debug: false,
        action: '/upload.php',
        // maximum number of concurrent uploads
        maxConnections: 999,
        onProgress: function(id, fileName, loaded, total){},
        onComplete: function(id, fileName, response){},
        onCancel: function(id, fileName){}
    };
    qq.extend(this._options, o);

    this._queue = [];
    // params for files in queue
    this._params = [];
};
qq.UploadHandlerAbstract.prototype = {
    log: function(str){
        if (this._options.debug && window.console) console.log('[uploader] ' + str);
    },
    /**
     * Adds file or file input to the queue
     * @returns id
     **/
    add: function(file){},
    /**
     * Sends the file identified by id and additional query params to the server
     */
    upload: function(id, params){
        var len = this._queue.push(id);

        var copy = {};
        qq.extend(copy, params);
        this._params[id] = copy;

        // if too many active uploads, wait...
        if (len <= this._options.maxConnections){
            this._upload(id, this._params[id]);
        }
    },
    /**
     * Cancels file upload by id
     */
    cancel: function(id){
        this._cancel(id);
        this._dequeue(id);
    },
    /**
     * Cancells all uploads
     */
    cancelAll: function(){
        for (var i=0; i<this._queue.length; i++){
            this._cancel(this._queue[i]);
        }
        this._queue = [];
    },
    /**
     * Returns name of the file identified by id
     */
    getName: function(id){},
    /**
     * Returns size of the file identified by id
     */
    getSize: function(id){},
    /**
     * Returns id of files being uploaded or
     * waiting for their turn
     */
    getQueue: function(){
        return this._queue;
    },
    /**
     * Actual upload method
     */
    _upload: function(id){},
    /**
     * Actual cancel method
     */
    _cancel: function(id){},
    /**
     * Removes element from queue, starts upload of next
     */
    _dequeue: function(id){
        var i = qq.indexOf(this._queue, id);
        this._queue.splice(i, 1);

        var max = this._options.maxConnections;

        if (this._queue.length >= max){
            var nextId = this._queue[max-1];
            this._upload(nextId, this._params[nextId]);
        }
    }
};

/**
 * Class for uploading files using form and iframe
 * @inherits qq.UploadHandlerAbstract
 */
qq.UploadHandlerForm = function(o){
    qq.UploadHandlerAbstract.apply(this, arguments);

    this._inputs = {};
};
// @inherits qq.UploadHandlerAbstract
qq.extend(qq.UploadHandlerForm.prototype, qq.UploadHandlerAbstract.prototype);

qq.extend(qq.UploadHandlerForm.prototype, {
    add: function(fileInput){
        fileInput.setAttribute('name', 'qqfile');
        var id = 'qq-upload-handler-iframe' + qq.getUniqueId();

        this._inputs[id] = fileInput;

        // remove file input from DOM
        if (fileInput.parentNode){
            qq.remove(fileInput);
        }

        return id;
    },
    getName: function(id){
        // get input value and remove path to normalize
        return this._inputs[id].value.replace(/.*(\/|\\)/, "");
    },
    _cancel: function(id){
        this._options.onCancel(id, this.getName(id));

        delete this._inputs[id];

        var iframe = document.getElementById(id);
        if (iframe){
            // to cancel request set src to something else
            // we use src="javascript:false;" because it doesn't
            // trigger ie6 prompt on https
            iframe.setAttribute('src', 'javascript:false;');

            qq.remove(iframe);
        }
    },
    _upload: function(id, params){
        var input = this._inputs[id];

        if (!input){
            throw new Error('file with passed id was not added, or already uploaded or cancelled');
        }

        var fileName = this.getName(id);

        var iframe = this._createIframe(id);
        var form = this._createForm(iframe, params);
        form.appendChild(input);

        var self = this;
        this._attachLoadEvent(iframe, function(){
            self.log('iframe loaded');

            var response = self._getIframeContentJSON(iframe);

            self._options.onComplete(id, fileName, response);
            self._dequeue(id);

            delete self._inputs[id];
            // timeout added to fix busy state in FF3.6
            setTimeout(function(){
                qq.remove(iframe);
            }, 1);
        });

        form.submit();
        qq.remove(form);

        return id;
    },
    _attachLoadEvent: function(iframe, callback){
        qq.attach(iframe, 'load', function(){
            // when we remove iframe from dom
            // the request stops, but in IE load
            // event fires
            if (!iframe.parentNode){
                return;
            }

            // fixing Opera 10.53
            if (iframe.contentDocument &&
                iframe.contentDocument.body &&
                iframe.contentDocument.body.innerHTML == "false"){
                // In Opera event is fired second time
                // when body.innerHTML changed from false
                // to server response approx. after 1 sec
                // when we upload file with iframe
                return;
            }

            callback();
        });
    },
    /**
     * Returns json object received by iframe from server.
     */
    _getIframeContentJSON: function(iframe){
        // iframe.contentWindow.document - for IE<7
        var doc = iframe.contentDocument ? iframe.contentDocument: iframe.contentWindow.document,
            response;

        this.log("converting iframe's innerHTML to JSON");
        this.log("innerHTML = " + doc.body.innerHTML);

        try {
            response = eval("(" + doc.body.innerHTML + ")");
        } catch(err){
            response = {};
        }

        return response;
    },
    /**
     * Creates iframe with unique name
     */
    _createIframe: function(id){
        // We can't use following code as the name attribute
        // won't be properly registered in IE6, and new window
        // on form submit will open
        // var iframe = document.createElement('iframe');
        // iframe.setAttribute('name', id);

        var iframe = qq.toElement('<iframe src="javascript:false;" name="' + id + '" />');
        // src="javascript:false;" removes ie6 prompt on https

        iframe.setAttribute('id', id);

        iframe.style.display = 'none';
        document.body.appendChild(iframe);

        return iframe;
    },
    /**
     * Creates form, that will be submitted to iframe
     */
    _createForm: function(iframe, params){
        // We can't use the following code in IE6
        // var form = document.createElement('form');
        // form.setAttribute('method', 'post');
        // form.setAttribute('enctype', 'multipart/form-data');
        // Because in this case file won't be attached to request
        var form = qq.toElement('<form method="post" enctype="multipart/form-data"></form>');

        var queryString = qq.obj2url(params, this._options.action);

        form.setAttribute('action', queryString);
        form.setAttribute('target', iframe.name);
        form.style.display = 'none';
        document.body.appendChild(form);

        return form;
    }
});

/**
 * Class for uploading files using xhr
 * @inherits qq.UploadHandlerAbstract
 */
qq.UploadHandlerXhr = function(o){
    qq.UploadHandlerAbstract.apply(this, arguments);

    this._files = [];
    this._xhrs = [];

    // current loaded size in bytes for each file
    this._loaded = [];
};

// static method
qq.UploadHandlerXhr.isSupported = function(){
    var input = document.createElement('input');
    input.type = 'file';

    return (
        'multiple' in input &&
        typeof File != "undefined" &&
        typeof (new XMLHttpRequest()).upload != "undefined" );
};

// @inherits qq.UploadHandlerAbstract
qq.extend(qq.UploadHandlerXhr.prototype, qq.UploadHandlerAbstract.prototype)

qq.extend(qq.UploadHandlerXhr.prototype, {
    /**
     * Adds file to the queue
     * Returns id to use with upload, cancel
     **/
    add: function(file){
        if (!(file instanceof File)){
            throw new Error('Passed obj in not a File (in qq.UploadHandlerXhr)');
        }

        return this._files.push(file) - 1;
    },
    getName: function(id){
        var file = this._files[id];
        // fix missing name in Safari 4
        return file.fileName != null ? file.fileName : file.name;
    },
    getSize: function(id){
        var file = this._files[id];
        return file.fileSize != null ? file.fileSize : file.size;
    },
    /**
     * Returns uploaded bytes for file identified by id
     */
    getLoaded: function(id){
        return this._loaded[id] || 0;
    },
    /**
     * Sends the file identified by id and additional query params to the server
     * @param {Object} params name-value string pairs
     */
    _upload: function(id, params){
        var file = this._files[id],
            name = this.getName(id),
            size = this.getSize(id);

        this._loaded[id] = 0;

        var xhr = this._xhrs[id] = new XMLHttpRequest();
        var self = this;

        xhr.upload.onprogress = function(e){
            if (e.lengthComputable){
                self._loaded[id] = e.loaded;
                self._options.onProgress(id, name, e.loaded, e.total);
            }
        };

        xhr.onreadystatechange = function(){
            if (xhr.readyState == 4){
                self._onComplete(id, xhr);
            }
        };

        // build query string
        params = params || {};
        params['qqfile'] = name;
        var queryString = qq.obj2url(params, this._options.action);

        xhr.open("POST", queryString, true);
        xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
        xhr.setRequestHeader("X-File-Name", encodeURIComponent(name));
        xhr.setRequestHeader("Content-Type", "application/octet-stream");
        xhr.send(file);
    },
    _onComplete: function(id, xhr){
        // the request was aborted/cancelled
        if (!this._files[id]) return;

        var name = this.getName(id);
        var size = this.getSize(id);

        this._options.onProgress(id, name, size, size);

        if (xhr.status == 200){
            this.log("xhr - server response received");
            this.log("responseText = " + xhr.responseText);

            var response;

            try {
                response = eval("(" + xhr.responseText + ")");
            } catch(err){
                response = {};
            }

            this._options.onComplete(id, name, response);

        } else {
            this._options.onComplete(id, name, {});
        }

        this._files[id] = null;
        this._xhrs[id] = null;
        this._dequeue(id);
    },
    _cancel: function(id){
        this._options.onCancel(id, this.getName(id));

        this._files[id] = null;

        if (this._xhrs[id]){
            this._xhrs[id].abort();
            this._xhrs[id] = null;
        }
    }
});