<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>

<script type="text/javascript">
    if (VCenter.selectedVCenter != null) {
        $('machineid').value = VCenter.selectedVCenter.machineId.toString();
        $('machinename').value = VCenter.selectedVCenter.machineName;
        $('machineip').value = VCenter.selectedVCenter.machineIp;
        $('username').value = VCenter.selectedVCenter.userName;
        $('password').value = '';
        $('vpassword').value = '';
        $('machineDisplayName').innerHTML = VCenter.selectedVCenter.machineIp;
    }
</script>
<!-- start : container (id #modalContent) -->
<!-- 
			notes:
					- include minMaxButton div within containerCenter if container can be minimized
					
					- special containerTab classes:
							containerWithTabs 	- container uses top aligned tabs
							
							twoSections/threeSections 	- container contains two/three sections - this sets up minimized titles positioning
							
							containerAlerts 	- alerts container - requires special containerCenter spacing
		-->
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <!-- start : container sections content blocks -->
        <!-- start : section (id #section_modalContent_0) -->
        <!-- 
					notes:
							- always includes:
								- sectionEditButtons block
								- sectionMessages block
							
							- optional includes:
								- sectionEditButton block
								- sectionMenu block
							
							- special containerSection classes:
									tableRowExpandedViewSection - section contained within table expanded row
																- uses different spacing for many elements ie. menu, messages, inner content
																- does not include another <form> tag 
									
									defaultShowEditModeOn 	- defaults the section to be in edit ie. edit buttons are visible
				-->
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn">
            <h2><fmt:message key="modifyVcenterAdminCredentials.title" />: <span id="machineDisplayName"></span></h2>
            <!-- start : section container -->
            <!-- 
						notes:
								- used to wrap section content in round orange border when in edit mode
					-->
                
                <div class="sectionContainer">
                    <div class="sectionTop">
                    </div>
                    <div class="sectionCenter">
                        <!-- start : section message block -->
                        <!-- 
							notes:
									- always available to contain and display messages
						-->
                        <div class="sectionMessages" id="section_modalContent_0_messages">
                            <!-- msg boxes inserted here -->
                        </div>
                        <!-- end : section message block -->
                        <!-- start : section form -->
                        <!-- 
								notes:
										- each section has only one form wrapping the entire section content
							-->
                        <form id="frmModifyVCenter" onsubmit="applyEditMode('section_modalContent_0',formHandler.send(this,urlConfig.modifyVCenterCredentials,{onStart:callbacks.showPleaseWaitMsgBox,closeModalOnSuccess:true,onSuccess:onVCenterPageLoad,msgArea:'section_2_0_messages'})); return false;" enctype="multipart/form-data"
                        method="post" action="#">
                        <!-- start : section content container -->
                        <!-- 
								notes:
										- used to wrap scrollable content area
							-->
                        
                            <!-- start : section content -->
                            <!-- 
									notes:
											- scrollable content area
								-->
<input type="hidden" id="machineid" name="machineId" value="" />
<input type="hidden" id="machinename" name="machineName" value="" />
<input type="hidden" id="machineip" name="machineIp" value="" />
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_9_1_0_0">
                                        <table class="dataFields" style="position: relative; top: -12px">
                                            <tbody>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription"></td>
                                                    <td class="fldDescription"></td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="generic.username" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="1" data-validate="notempty" data-validate-display="generic.username" type="text" value="" onblur="toggleHighlightRow('username');modifyVCenterWatermark(this);" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('username');"
                                                            size="28" style="width: 14em;" name="userName" id="username" class="inputFldText domainWatermark"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="generic.password" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="2" data-validate="match;notempty" data-validate-display="generic.password" type="password" value="" onblur="toggleHighlightRow('password');" onfocus="toggleHighlightRow('password');"
                                                            size="28" style="width: 14em;" name="password" id="password" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="generic.verifyPassword" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="3" data-validate="match;notempty" data-validate-display="generic.verifyPassword" type="password" value="" onblur="toggleHighlightRow('vpassword');" onfocus="toggleHighlightRow('vpassword');"
                                                            size="28" style="width: 14em;" name="vPassword" id="vpassword" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td colspan="2" class="fldValue" style="text-align: left">&nbsp;<br />
                                                        <span style="font-weight: bold"><fmt:message key="generic.note" />:</span> <fmt:message key="modifyVcenterAdminCredentials.note" /></td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <!-- end : data fields table -->
                                    </div>
                                    
                                    <div class="clear">
                                    </div>
                                </div>
                                <!-- end : content block group -->
                                <div class="clear">
                                </div>
                            </div>
                            <!-- end : section content -->
                        
                        <!-- end : section content container -->
                        <!-- start : section edit buttons -->
                        <div class="sectionEditButtons">
                            <button tabindex="5" id="btnModifyCancel" onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton" onblur="restartTabbingOrder('frmModifyVCenter');"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.cancel" /></span></button>
                            <button tabindex="4" id="btnModify" class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                                <span><fmt:message key="generic.apply" /></span></button>
                        </div>
                        <!-- end : section edit buttons -->
                        </form>
                        <!-- end : section form -->
                    </div>
                    <div class="sectionBottom">
                    </div>
                </div>
                <!-- end : section container -->
            </div>
            
            
        <!-- end : section (id #section_modalContent_0) -->
        <!-- end : container sections content blocks -->
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<script type="text/javascript">
    //formUtils.setupWatermarks('frmModifyVCenter');
</script>
<!-- end : container (id #modalContent) -->
