<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn">
            <h2><fmt:message key="restoreNow.title" /></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div id="section_modalContent_0_messages" class="sectionMessages">
                    </div>
                    <form id="frmRestore" method="post" enctype="multipart/form-data" onsubmit="formHandler.send(this,urlConfig.restore,{onStart:callbacks.showPleaseWaitMsgBox,closeModalOnSuccess:true,onSuccess:onLoadBackupPage,msgArea:'section_30_0_messages'}); return false;">
                        <div class="sectionContent">
                            <div class="contentBlockGroup oneColumnGroup">
                                <div id="block_section_modalContent_0_0_0" class="contentBlock">
                                    <fmt:message key="restoreNow.networkShareLocationInstructions" />:
                                        <table class="dataFields">
                                            <tbody>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="restoreNow.fileLocation" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="31" data-validate="notempty" data-validate-display="backupAndRestore.restoreNow.backupFileLocation" type="text" value="" onblur="toggleHighlightRow('restore_username');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('restore_username');"
                                                        size="28" style="width: 14em;" name="share" id="restore_file_path" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="generic.username" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="32" type="text" value="" onblur="toggleHighlightRow('restore_username');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('restore_username');"
                                                        size="28" style="width: 14em;" name="user" id="restore_username" class="inputFldText domainWatermark"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="generic.password" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="33" type="password" value="" onblur="toggleHighlightRow('restore_password');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('restore_password');"
                                                        size="28" style="width: 14em;" name="password" id="restore_password" class="inputFldPassword"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="generic.encryptionPassword" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="34" data-validate="notempty" data-validate-display="backupAndRestore.restoreNow.passwordForEncryption" type="password" value="" onblur="toggleHighlightRow('restore_encpassword');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('restore_encpassword');"
                                                        size="28" style="width: 14em;" name="encryptionPassword" id="restore_encpassword" class="inputFldPassword"/>
                                                    </td>
                                                </tr>
                                             <tr>
                                               <td colspan="2" style="text-align: left">&nbsp;<br />
							  						<b><fmt:message key="generic.note" />:</b> <fmt:message key="restoreNow.encyrptionPasswordNote" />
							  						<br />
							  						<br />		
						         					<b><fmt:message key="generic.caution" />:</b> <fmt:message key="restoreNow.rebootCaution" />
												</td>
                                              </tr>
                                            </tbody>
                                        </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear">
                            </div>
                        </div>
                    <div class="sectionEditButtons">
                        <button tabindex="36" type="reset" value="reset" id="btnRestoreNowCancel" class="stdButton" onclick="cancelEditMode('section_modalContent_0'); return false;" onblur="restartTabbingOrder('frmRestore');">
                            <span><fmt:message key="generic.cancel" /></span></button>
                        <button tabindex="35" type="submit" id="btnRestoreNow" value="submit" class="stdButton stdButtonEmphasized1">
                            <span><fmt:message key="generic.apply" /></span></button>
                    </div>
                    <input type="hidden" id="restore_domain" name="domain" value="" /><!-- place holder so doesn't break existing ajax call -->
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<script type="text/javascript">
   bindDisableInputsIfDoesNotStartsWith('restore_file_path', "\\\\", ['restore_username', 'restore_password']);
   formUtils.setupWatermarks('frmRestore');
</script>
