<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
    if (VCenter.selectedVCenter != null) {
        $('machineid').value    = VCenter.selectedVCenter.machineId.toString();
        $('machinename').value  = VCenter.selectedVCenter.machineName;
        $('machineip').value    = VCenter.selectedVCenter.machineIp;
    }
</script>

<!-- start : container (id #modalContent) -->
<!--
			notes:
					- include minMaxButton div within containerCenter if container can be minimized

					- special containerTab classes:
							containerWithTabs 	- container uses top aligned tabs

							twoSections/threeSections 	- container contains two/three sections - this sets up minimized titles positioning

							containerAlerts 	- alerts container - requires special containerCenter spacing
-->
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <!-- start : container sections content blocks -->
        <!-- start : section (id #section_modalContent_0) -->
        <!--
					notes:
							- always includes:
								- sectionEditButtons block
								- sectionMessages block

							- optional includes:
								- sectionEditButton block
								- sectionMenu block

							- special containerSection classes:
									tableRowExpandedViewSection - section contained within table expanded row
																- uses different spacing for many elements ie. menu, messages, inner content
																- does not include another <form> tag

									defaultShowEditModeOn 	- defaults the section to be in edit ie. edit buttons are visible
				-->
        <div id="section_modalContent_3" class="containerSection defaultShowEditModeOn">
        	<h2><fmt:message key="updateVcenterCertificate.title"/></h2>
            <!-- start : section container -->
            <!--
						notes:
								- used to wrap section content in round orange border when in edit mode
					-->

                <div class="sectionContainer">
                    <div class="sectionTop">
                    </div>
                    <div class="sectionCenter">
                        <!-- start : section message block -->
                        <!--
							notes:
									- always available to contain and display messages
						-->
                        <div class="sectionMessages" id="section_modalContent_3_messages">
                            <!-- msg boxes inserted here -->
                        </div>
                        <!-- end : section message block -->
                        <!-- start : section form -->
                        <!--
								notes:
										- each section has only one form wrapping the entire section content
							-->
                        <form id="frmUpdateVCenter" onsubmit="applyEditMode('section_modalContent_3', updateVCenter); return false;" enctype="multipart/form-data"
                        method="post" action="#">
                        <!-- start : section content container -->
                        <!--
								notes:
										- used to wrap scrollable content area
							-->

                            <!-- start : section content -->
                            <!--
									notes:
											- scrollable content area
								-->
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_3_0_0_0">
                                        <div style="float:left;margin:0 35px;">
                                            <img id="update_status_icon" src="images/loading_icon.gif" alt="" />
                                        </div>
                                        <div id="update_status" style="float:left;margin:20px 0;width:200px;"></div>
                                        <input type="hidden" id="machineid" name="machineId" value="" />
                                        <input type="hidden" id="machinename" name="machineName" />
                                        <input type="hidden" id="machineip" name="machineIp" />
                                        <!-- end : data fields table -->
                                    </div>

                                    <div class="clear">
                                    </div>
                                </div>
                                <!-- end : content block group -->
                                <div class="clear">
                                </div>
                            </div>
                            <!-- end : section content -->

                        <!-- end : section content container -->
                        <!-- start : section edit buttons -->
                        <div class="sectionEditButtons">
                            <!--<button class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                                <span>Apply</span>
                            </button>-->
                            <button onclick="cancelEditMode('section_modalContent_3'); return false;" class="stdButton"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.close" /></span></button>
                        </div>
                        <!-- end : section edit buttons -->
                        </form>
                        <!-- end : section form -->
                    </div>
                    <div class="sectionBottom">
                    </div>
                </div>
                <!-- end : section container -->
            </div>


        <!-- end : section (id #section_modalContent_0) -->
        <!-- end : container sections content blocks -->
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<script type="text/javascript">
	$('update_status').innerHTML = Translator.translate('vcenterRegistration.updatingCertificate', { MACHINE_NAME: VCenter.selectedVCenter.machineIp });
    formHandler.send('frmUpdateVCenter',urlConfig.updateVCenterCertificate,
        {
            msgArea:'section_2_0_messages',
            cancelDefaultMessage:true,
            onSuccess:function(responseObj){
                var selector = $('update_status'),
                    checkImg = new Image();
                checkImg.src = 'images/icons/icn_check_lg.png';
                selector.innerHTML = responseObj.errorMessage;
                Element.replace( $('update_status_icon'), checkImg )
            },
            onError:function(responseObj){
                var selector = $('update_status'),
                    checkImg = new Image();
                checkImg.src = 'images/icons/icn_fail_lg.png';
                selector.innerHTML = responseObj.errorMessage;
                Element.replace( $('update_status_icon'), checkImg )
            }
        }
    );
</script>
<!-- end : container (id #modalContent) -->
