<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
    var currentVersion   = $('current_appliance_version').innerHTML,
        availableVersion = $('available_appliance_version').innerHTML;

    if( $('upgradePossible').value == 'true' ){
        $('currentApplianceVersion').innerHTML = currentVersion;
        $('availableApplianceVersion').innerHTML = availableVersion;
        $('view-1').setStyle({display:'block'})
    }else{
        $('view-2').setStyle({display:'block'})
        $('btnUpgrade').addClassName('stdButtonDisabled').setAttribute('disabled','disabled');
    }
    
</script>
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn">
            <h2><fmt:message key="updateAppliance.title"/></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div class="sectionMessages" id="section_modalContent_0_messages">
                    </div>
                    <form id="frmUpdateAppliance" onsubmit="applyEditMode('section_modalContent_0', formHandler.send(this,urlConfig.updateVirtualAppliance,{onStart:callbacks.showPleaseWaitMsgBox,closeModalOnSuccess:true,onSuccess:submitLogout}));return false;" enctype="multipart/form-data" method="post">
                        <div id="view-1" class="swap-area">
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_9_1_0_0" style="width:100%;">
                                        <p style="float:right;width:270px;margin-top:10px;margin-bottom:15px;">
                                            <fmt:message key="updateAppliance.currentVersion"/>: <span id="currentApplianceVersion"></span><br />
                                            <fmt:message key="updateAppliance.availableVersion"/>: <span id="availableApplianceVersion"></span><br /><br />
                                            <!--The Administration Portal will not be available until after the upgrade is complete.-->
                                        </p>
                                        <div class="statusLargeIcon statusLargeInfoIcon"></div>
                                        <p><fmt:message key="updateAppliance.messages.beforeUpdateTitle"/>:</p>
                                        <ol style="disk">
                                            <li><fmt:message key="updateAppliance.messages.beforeUpdateItem1"/></li>
                                            <li><fmt:message key="updateAppliance.messages.beforeUpdateItem2"/></li>
                                        </ol>
                                        <p>
                                            <fmt:message key="updateAppliance.messages.updateExplanation"/>
                                        </p>
                                    </div>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <input type="hidden" id="updateAppliance" value="true" />
                        </div>

                        <div id="view-2" class="swap-area">
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_9_1_0_0" style="width:100%;">
                                        <p style="float:right;width:270px;margin-top:10px;margin-bottom:15px;">
                                            <fmt:message key="updateAppliance.messages.noNewVersionAvailable"/>
                                        </p>
                                        <div class="statusLargeIcon statusLargeInfoIcon"></div>
                                    </div>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                        </div>

                        <div class="sectionEditButtons">
                            <button onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton" onblur="restartTabbingOrder('frmUpdateAppliance');"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.cancel"/></span>
                            </button>
                            <button onclick="" id="btnUpgrade" class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                                <span><fmt:message key="generic.update"/></span>
                            </button>
                        </div>
                    </form>

                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
