<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
    var cancelBtn = "<button tabindex=\"3\" onclick=\"cancelEditMode('section_modalContent_0'); return false;\" class=\"stdButton\"value=\"reset\" type=\"reset\" onblur=\"restartTabbingOrder('frmUploadCertificate');\"><span>" + Translator.translate("generic.cancel") + "</span></button>";
    var uploader = new qq.FileUploader({
      template: '<div class="qq-uploader">' +
                '<div class="qq-upload-drop-area"><span>' + Translator.translate("fileUpload.messages.dropFilesInstructions") + '</span></div>' +
                '<div class="qq-browse-button"><span>' + Translator.translate("generic.browse") + '</span></div>' +
                '<div class="divider">' + cancelBtn + '<div tabindex=\"2\" id="btn-upload" class="qq-upload-button"><span>' + Translator.translate("generic.upload") + '</span></div></div>' +
                '<ul class="qq-upload-list"></ul>' +
                '</div>',
      element: $('uploadCertificateFile'),
      action: urlConfig.uploadLicense,
      onSubmit:function(id,fileName){
          $('txtLicenseFilePath').value = fileName;
      },
      showMessage:function(){},
      onComplete: function (id, fileName, responseJSON) {
    	  checkSessionEx();	
          var resp = responseJSON.UploadLicense;
          if(resp.responseCode == 0){
    			callbacks.modalShowLargeSuccessIcon(resp);
              onVCenterPageLoad();
          }else{
    			callbacks.modalShowLargeFailureIcon(resp);
          }
      }
    });

    $$('.qq-upload-button input')[0].observe('click',function(){
        showHide('view-2','view-1');
    })
</script>


<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn">
            <h2><fmt:message key="uploadLicense.title" /></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">

                    <div id="view-1" class="swap-area" style="display:block;">
                        <form id="frmUploadCertificate" enctype="multipart/form-data" method="post">
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_9_1_0_0" style="width:100%;">
                                        <p style="float:right;width:270px;margin-top:10px;margin-bottom:25px;">
                                            <fmt:message key="uploadLicense.instructions" />
                                        </p>
                                        <div class="statusLargeIcon statusLargeInfoIcon"></div>
                                        <div style="clear:both;"></div>
                                        <div id="file-uploader">
                                        </div>
                                        <div>
                                            <input tabindex="1" type="text" id="txtLicenseFilePath" disabled="disabled" class="requiredField disabled" displayname="License File" jsonfieldname="txtLicenseFilePath" tabid="tab_licensingLicenseFile" style="position:absolute;"/>
                                            <div id="uploadCertificateFile">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                        </form>
                    </div>

                    <div id="view-2" class="swap-area">
                        <div style="float:left;margin:15px 35px;">
                            <img id="update_status_icon" src="images/loading_icon.gif" alt="" />
                        </div>
                        <div id="update_status" style="float:left;margin:20px 0;width:200px;"><!-- status msg --></div>
                    </div>

                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
