<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
 onLoadBackupPage();	
 $('timezone').innerHTML = buildTimeZoneDesignation();
</script>
<h1 id="pagetitle"><fmt:message key="backupAndRestore.title" /></h1>
<div id="container_30" class="container">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_30_0" class="containerSection">
            <h2><fmt:message key="backupAndRestore.backupAndRestoreSettings" /></h2>
            <div class="sectionContainer">
                <div class="sectionTop"></div>
                <div class="sectionCenter">
                    <div id="section_30_0_menu" class="sectionMenu">
                        <a class="modalIconLink" href="javascript:openBackupNowModalAndCloseSectionMessage(urlConfig.viewBackupNowModal, 'halfWidth');">
                            <fmt:message key="backupAndRestore.backupNow" /></a>
                        <div class="sectionMenuDivider"></div>
                        <a class="modalIconLink" href="javascript:openRestoreModalAndCloseSectionMessage(urlConfig.viewRestoreModal, 'halfWidth');">
                            <fmt:message key="backupAndRestore.restoreNow" /></a>
                    </div>
                    <div style="margin-top:15px;position:relative;">
                        <h2><fmt:message key="backupAndRestore.settingsAndDetailsTitle" /></h2>
                        <div class="sectionEditButton" onclick="clearBackupSettingsPassword();editButtonClickForSimpleForm('section_30_0', 'block_section_30_0_0_1');clearBackupSettingsVPassword();bindDisableInputsIfDoesNotStartsWith('backupLocation', '\\\\', ['userName', 'backupLocationPassword']);BackupSettingsWatermark();" style="top:2px;">
                            <div class="sectionEditButtonInner"><fmt:message key="generic.edit" /></div>
                        </div>
                    </div>
                    <!--<form method="post" enctype="multipart/form-data" onsubmit="hidePasswordTR(); hideVPasswordTR(); applyEditModeForSimpleForm('section_30_0', setBackupShare); return false;">-->
                    <form id="frmBackupSettings" method="post" enctype="multipart/form-data" onsubmit="clearTestConnectionResult();hidePasswordTR(); hideVPasswordTR(); applyEditModeForSimpleForm('section_30_0', formHandler.send(this,urlConfig.saveBackupSettings,{onError:clearBackupSettingsForm}) );return false;">
                    <div class="sectionContentContainer">
                        <div id="section_30_0_messages" class="sectionMessages">
                            <div id="msgBox_section_30_0_0" class="msgBox msgInfo">
                                <div class="msgIcon">
                                </div>
                                <div class="msgContent" style="height: auto">
                                    <table class="msgTable" style="height: auto">
                                        <tr>
                                            <td style="height: auto">
                                                <div class="msgTitle">
                                                    <fmt:message key="generic.information" /></div>
                                            </td>
                                            <td class="maxWidthCol" style="height: auto">
                                               <div id="msgText_section_30_0_0" class="msgText" style="height: auto">
                                                    <fmt:message key="backupAndRestore.messages.settingsAndDetailsInstructions" />
                                                </div>

                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <div class="sectionContent">
                            <div class="contentBlockGroup">
                                <div id="block_section_30_0_0_1" class="contentBlock">
                                    <table class="dataFields">
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.lastBackupDate" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span id="lastBackupDate"></span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.lastBackupStatus" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span id="lastBackupStatus"></span>
                                            </td>
                                        </tr>
                                        <tr><td colspan="2"></td></tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.backupLocation" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="1" id="backupLocation" class="inputFldText watermarkOnEdit" helptext="<fmt:message key="generic.notConfigured" />" size="30" onfocus="clearIfHelpText(this);"></span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="generic.username" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="2" id="userName" class="inputFldText watermarkOnEdit" helptext="<fmt:message key="generic.notConfigured" />" size="30" onfocus="clearIfHelpText(this);"></span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="generic.password" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="3" id="backupLocationPassword" class="inputFldPassword watermark" size="30" onfocus="formUtils.clearWatermarks(this);">**********</span>
                                            </td>
                                        </tr>
                                        <tr><td colspan="2"></td></tr>
                                        <tr class="dataFieldRow">
                                            <td colspan="2"><fmt:message key="backupAndRestore.messages.encryptBackupsInstructions" /></td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="generic.password" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="4" id="encryptionPassword" class="inputFldPassword" size="30">**********</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="generic.verifyPassword" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="5" id="encryptionVPassword" class="inputFldPassword" size="30">**********</span>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear"></div>
                            <div class="testValidate" style="margin-top:10px;">
                                <div class="status-message">
                                <script type="text/javascript">
                                <fmt:message key="backupAndRestore.testingrepolocation" var="testingrepolocation"/>
                                    applianceUpdateValidation = {
                                        cancelDefaultMessage:true,
                                        onStart:function(){
                                            $('val_icn_app_update').addClassName('val-waiting');
                                            $('val_msg_app_update').innerHTML = "${testingrepolocation}";
                                            disableButton('btnValidateApplianceUpdate');
                                        },
                                        onSuccess:function(responseObj){
                                        	$('val_icn_app_update').removeClassName('val-fail');
                                            $('val_icn_app_update').addClassName('val-success');
                                            $('val_msg_app_update').innerHTML = responseObj.errorMessage;
                                            enableButton('btnValidateApplianceUpdate');
                                        },
                                        onError:function(responseObj){
                                        	$('val_icn_app_update').removeClassName('val-success');
                                            $('val_icn_app_update').addClassName('val-fail');
                                            $('val_msg_app_update').innerHTML = responseObj.errorMessage;
                                            enableButton('btnValidateApplianceUpdate');
                                        }
                                    }
                                </script>
                            		<button tabindex="6" id="btnValidateApplianceUpdate" class="stdButton btnValidate" style="float: right;" onclick="formHandler.send('frmBackupSettings',urlConfig.validateBackupSettings,applianceUpdateValidation);" type="button"><span><fmt:message key="generic.test" /></span></button>
                            		<span id="val_icn_app_update" style="float: left;" class="status_icon"></span>
                            		<span id="val_msg_app_update" style="display: table-cell; text-align: left; padding-left: 20px; padding-right: 20px;" class="msg-text"></span>
                            	</div>
                            </div>
													<div class="clear"></div>
                        </div>
                    </div>
                    <div class="sectionEditButtons">
                        <button tabindex="8" type="reset" value="reset" class="stdButton" onclick="clearTestConnectionResult(); hidePasswordTR(); hideVPasswordTR(); cancelEditMode('section_30_0'); return false;" onblur="restartTabbingOrder('frmBackupSettings');">
                            <span><fmt:message key="generic.cancel" /></span></button>
                        <button tabindex="7" type="submit" value="submit" class="stdButton stdButtonEmphasized1">
                            <span><fmt:message key="generic.apply" /></span></button>
                    </div>
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
        <div class="minMaxButton" onclick="toggleContainerMinMax('container_30');">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<div id="container_31" class="container">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_31_0" class="containerSection">
            <h2><fmt:message key="backupAndRestore.automaticScheduledBackupTitle" /></h2>
            <div class="sectionEditButton" onclick="editButtonClickForSimpleForm('section_31_0', 'block_section_31_0_0_1');addAutoBackupScheduleEvents();">
                <div class="sectionEditButtonInner"><fmt:message key="generic.edit" /></div>
            </div>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div id="section_31_0_messages" class="sectionMessages">
                        <div id="msgBox_section_31_0_0" class="msgBox msgInfo">
                            <div class="msgIcon">
                            </div>
                            <div class="msgContent">
                                <table class="msgTable">
                                    <tr>
                                        <td>
                                            <div class="msgTitle">
                                                <fmt:message key="generic.information" /></div>
                                        </td>
                                        <td class="maxWidthCol">
                                            <div id="msgText_section_31_0_0" class="msgText">
                                                <fmt:message key="backupAndRestore.messages.automaticScheduledBackupInstructions" />
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>
                    <form id="frmBackupSchedule" method="post" enctype="multipart/form-data" onsubmit="applyEditModeForSimpleForm('section_31_0', setBackupSchedule); onLoadBackupPage(); return false;">
                    <div class="sectionContentContainer">
                        <div class="sectionContent">
                            <div class="contentBlockGroup">
                                <div id="block_section_31_0_0_1" class="contentBlock">
                                    <table class="dataFields">
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.automaticScheduledBackups" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="10" id="enabled_state" class="inputFldRadio" optionvals="generic.enabled|generic.disabled"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="backupAndRestore.daysForBackup" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="12" id="days" class="inputFldCheckbox" optionvals="generic.sundayAbbrev|generic.mondayAbbrev|generic.tuesdayAbbrev|generic.wednesdayAbbrev|generic.thursdayAbbrev|generic.fridayAbbrev|generic.saturdayAbbrev"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span class="indent"><fmt:message key="backupAndRestore.timeForBackup" /></span>
                                            </td>
                                            <td class="fldValue">
                                               <span tabindex="19" id="timeOfBackup" class="inputFldText watermarkOnEdit" helptext="<fmt:message key="generic.notConfigured" />" size="20" onfocus="clearIfHelpText(this);"><fmt:message key="generic.hoursMinutesFormat" /></span>  
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.nextBackup" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span id="nextBackup"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="backupAndRestore.localTimezone" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span id="timezone"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear">
                            </div>
                        </div>
                    </div>
                    <div class="sectionEditButtons">
                        <button tabindex="21" type="reset" value="reset" class="stdButton" onclick="cancelEditMode('section_31_0'); reloadAutomaticBackupSchedule(); return false;" onblur="restartTabbingOrder('frmBackupSchedule');">
                            <span><fmt:message key="generic.cancel" /></span></button>
                        <button tabindex="20" type="submit" value="submit" class="stdButton stdButtonEmphasized1">
                            <span><fmt:message key="generic.apply" /></span></button>
                    </div>
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
        <div class="minMaxButton" onclick="toggleContainerMinMax('container_31');">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
