<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
	//Hide all the messages at page load.
	//They will be loaded after the license information will be retrieved from the server
	$('unlicensedHostsRow').hide();
	$('hostLicenseWarning').hide();
	$('hostLicenseNoRemaining').hide();
	onVCenterPageLoad();
</script>
<h1 id="pagetitle"><fmt:message key="vcenterRegistration.title"/></h1>
<div id="container_2" class="container">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_2_0" class="containerSection">
        	<h2><fmt:message key="vcenterRegistration.manageVcenterServerConnections"/></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div class="sectionMenu">
                        <span class="subTitle"><fmt:message key="vcenterRegistration.registeredVcenters"/></span>
                    </div>
                    <div id="section_2_0_menu" class="sectionMenu">
                        <span><fmt:message key="generic.tasks"/>:</span>
                        <a class="modalIconLink" onclick="openModalAndCloseSectionMessage(urlConfig.viewRegisterModal, 'halfWidth', 0);" href="#"><fmt:message key="vcenterRegistration.registerNewVcenterServer"/></a>
                        <div class="sectionMenuDivider"></div>
                        <a class="modalIconLink" onclick="openModalAndCloseSectionMessage(urlConfig.viewUploadLicenseModal, 'halfWidth', 0);" href="#"><fmt:message key="vcenterRegistration.uploadLicense"/></a>
                    </div>
                    <div id="section_2_0_messages" class="sectionMessages">
                    </div>
                    <form onsubmit="applyEditMode('section_2_0'); return false;">
                    <div class="sectionContent tableContent">
                        <div id="section_2_0_0" class="scrollAreaContainer">
                            <div class="tableOverlayTop" style="display: none;">
                            </div>
                            <div class="tableOverlaySideLeft">
                            </div>
                            <div class="tableOverlaySideRight">
                            </div>
                            <div class="tableOverlayBottom">
                            </div>
                            <div class="tableHighlightOverlaySideLeft" style="display: none;">
                            </div>
                            <div class="tableHighlightOverlaySideRight" style="display: none;">
                            </div>
                            <div id="section_2_0_0_inner" class="scrollAreaInnerContainer">
                                <div id="section_2_0_0_content" class="scrollAreaContent">
                                    <table id="section_2_0_0_table" class="sectionTable">
                                        <thead>
                                            <tr>
                                                <th class="firstCol">
                                                    <fmt:message key="vcenterRegistration.listingTable.vcenterServerIpOrHostnameHeader"/>
                                                </th>
													<th class="" style="white-space: normal; width: 120px;">
                                                    <fmt:message key="vcenterRegistration.listingTable.descriptionHeader"/>
                                                </th>
                                                <th class="iconCol ">
                                                    <fmt:message key="vcenterRegistration.listingTable.credentialsHeader"/>
                                                </th>
                                                <th class="iconCol">
                                                    <fmt:message key="vcenterRegistration.listingTable.certificateHeader"/>
                                                </th>
                                                <th class="iconCol">
                                                    <fmt:message key="vcenterRegistration.listingTable.unregisterHeader"/>
                                                </th>
                                                <th class="lastCol">
                                                    <div>
                                                    </div>
                                                </th>
                                            </tr>
                                            <tr>
                                                <td class="tableTop" colspan="5">
                                                </td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="tableBottom" colspan="7">
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                        </div>
                        <div id="section_2_0_0_scrollbar_track" class="scrollBarTrack" style="display: none;">
                            <div id="section_2_0_0_scrollbar_track_handle" class="scrollBarHandle">
                            </div>
                        </div>
                        <div class="clear">
                        </div>
                    </div>
                </form>
            </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom"></div>
</div>
<fmt:message key="generic.buyNowAddress" var="buyNowAddress" />

<div id="container_3" class="container">
    <div class="containerTop"></div>
	<div class="containerCenter">
		<div id="section_22_0" class="containerSection minContainerHeight">
            <h2><fmt:message key="vcenterRegistration.licensing"/></h2>
            <div id="license_purchase_link" style="display: none;">
            	<br/>
				<button type="button" style="vertical-align: middle;" title="<fmt:message key='BUY_NOW_TOOLTIP' />" onclick=" window.open('${buyNowAddress}', '_blank') "><fmt:message key="generic.buyNow"/></button></div>
            <form onsubmit="applyEditMode('section_22_0'); return false;">
            <div class="sectionContainer">
                <div class="sectionTop"></div>
                    <div class="sectionCenter" style="width:300px;">
                        <div class="sectionMenu">
                            <span class="subTitle"><fmt:message key="vcenterRegistration.hostConnectionLicenses"/></span>
                        </div>
						<div class="sectionMenu" id="hostLicenseWarning" style="color: #CC0000; display: none;">
                            <span class="statusSmallIcon statusSmallWarningIcon"></span>
                            <span>&nbsp <fmt:message key="vcenterRegistration.messages.numberOfHostLicensesExceeded"/></span>
                        </div>
                        <div class="sectionMenu" id="hostLicenseNoRemaining">
                            <span class="statusSmallIcon statusSmallInfoIcon"></span>
                            <span>&nbsp <fmt:message key="vcenterRegistration.messages.noHostLicensesRemaining"/></span>
                        </div>
                        <div class="twoColumnStaticTableWrapper">
                            <div class="contentBlock">
                        <table class="dataFields">
                        <tr class="dataFieldRow">
                        <td class="fldDescription"><span><fmt:message key="vcenterRegistration.maximumHostConnectionLicenses"/></span></td>
                        <td class="dataValue" id="maxHosts"><fmt:message key="generic.loading"/></td>
                        </tr>
                        <tr class="dataFieldRow">
                        <td class="fldDescription"><span class="indent"><fmt:message key="generic.inUse"/></span></td>
                        <td class="dataValue" id="hostsUsed"><fmt:message key="generic.loading"/></td>
                        </tr>
                        <tr class="dataFieldRow">
                            <td class="fldDescription"><span class="indent"><fmt:message key="generic.available"/></span></td>
                            <td class="dataValue" id="hostsRemaining"><fmt:message key="generic.loading"/></td>
                        </tr>
									<tr id="unlicensedHostsRow" class="dataFieldRow" style="color: #CC0000; display: none;">
                            <td class="fldDescription" style="color:#CC0000"><span class="indent"><fmt:message key="vcenterRegistration.unlicensedHosts"/></span></td>
                            <td class="dataValue" id="unlicensedHosts" style="color:#CC0000"><fmt:message key="generic.loading"/></td>
                        </tr>
                        </table>
                            </div>
                        </div>
                    </div>
                <div style="clear:both;"></div>
                    <div class="sectionCenter" style="width:300px;">
                        <div class="sectionMenu licenseInfoArea" style="margin-top:10px;">
                        <span class="subTitle"><fmt:message key="vcenterRegistration.vcenterConnectionLicenses"/>:</span>
                        </div>
                        <div class="sectionMenu" id="vCenterLicenseInfo" style="display:none;">
                            <span class="statusSmallIcon statusSmallInfoIcon"></span>
                            <span>&nbsp <fmt:message key="vcenterRegistration.messages.noVcenterLicensesRemaining"/></span>
                        </div>
                        <div class="twoColumnStaticTableWrapper">
                        <div class="contentBlock">
                                <table class="dataFields">
                                        <tr class="dataFieldRow">
                                                <td class="fldDescription"><span><fmt:message key="vcenterRegistration.maximumVcenterConnectionLicenses"/></span></td>
                                                <td class="dataValue" id = "maxVCenters"><fmt:message key="generic.loading"/></td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                                <td class="fldDescription"><span class="indent"><fmt:message key="generic.inUse"/></span></td>
                                                <td class="dataValue" id = "vCentersUsed"><fmt:message key="generic.loading"/></td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                                <td class="fldDescription"><span class="indent"><fmt:message key="generic.available"/></span></td>
                                                <td class="dataValue" id = "vCentersRemaining"><fmt:message key="generic.loading"/></td>
                                        </tr>
                                </table>
                        </div>
                        </div>
                    </div>
				</div>
			</form>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
