<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">

    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn" style="padding-bottom: 0px">
            <h2><fmt:message key="backupNow.title" /></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div id="section_modalContent_0_messages" class="sectionMessages">
                    </div>
					<br/>
                    <input id="chkUseShare" type="checkbox" onclick="disableControlsInElement($('block_section_modalContent_0_0_0'),this.checked);"/> <span id="chkUserShareText"> <fmt:message key="backupNow.useLocationAndEncryptionPasswordFromBackupSettings" /> </span>
                    <form id="frmBackupNow" method="post" enctype="multipart/form-data" onsubmit="backupModalSubmitHandler();return false;">
                        <div class="sectionContent">
                            <div class="contentBlockGroup oneColumnGroup">
                                <div id="block_section_modalContent_0_0_0" class="contentBlock">                                    
                                        <table class="dataFields">
                                            <tbody>
                                                <tr class="dataFieldRow">
                                                	<td colspan="2" style="text-align: left">
				                                        <span><fmt:message key="backupNow.networkSharedFolderInstructions" />:</span>
	                                                </td>
                                            	</tr>
											    <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="backupNow.backupLocation" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="21" data-validate="notempty" data-validate-display="backupAndRestore.backupNow.backupLocation" type="text" value="" onblur="toggleHighlightRow('backup_file_path');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('backup_file_path');"
                                                        size="28" style="width: 14em;" name="share" id="backup_file_path" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="generic.username" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="22" data-validate-display="generic.username" type="text" value="" onblur="toggleHighlightRow('backup_username');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('backup_username');"
                                                        size="28" style="width: 14em;" name="user" id="backup_username" class="inputFldText domainWatermark"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="generic.password" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="23" type="password" value="" onblur="toggleHighlightRow('backup_password');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('backup_password');"
                                                        size="28" style="width: 14em;" name="password" id="backup_password" class="inputFldPassword"/>
                                                    </td>
                                                </tr>                                                
                                                <tr class="dataFieldRow">
                                                	<td  colspan="2" style="text-align: left">
                                                        <span style="padding-top: 2px" class="partial-indent"><b><fmt:message key="generic.note" />:</b> <fmt:message key="backupNow.backupLocationPasswordNote" /></span>
	                                                </td>
                                            	</tr>
                                               <tr class="dataFieldRow">
                                                	<td  colspan="2" style="text-align: left"><br/>
                                                    <span><fmt:message key="generic.encryptionPassword" />:</span>
                                                	</td>
                                            	</tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="backupNow.passwordForEncryption" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="24" data-validate="match;notempty" data-validate-display="backupAndRestore.backupNow.passwordForEncryption" type="password" value="" onblur="toggleHighlightRow('backup_encpassword');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('backup_encpassword');"
                                                        size="28" style="width: 14em;" name="encryptionPassword" id="backup_encpassword" class="inputFldPassword"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span class="partial-indent"><fmt:message key="generic.verifyPassword" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="25" data-validate="match" data-validate-display="backupAndRestore.backupNow.passwordForEncryption" type="password" value="" onblur="toggleHighlightRow('backup_encpassword');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('backup_encvpassword');"
                                                        size="28" style="width: 14em;" name="encryptionVPassword" id="backup_encvpassword" class="inputFldPassword"/>
                                                    </td>
                                                </tr>
                                               <tr class="dataFieldRow">
                                                <td colspan="2" style="text-align: left">
                                                    <span style="padding-top: 2px" class="partial-indent"><b><fmt:message key="generic.note" />:</b> <fmt:message key="backupNow.encryptionPasswordNote" /></span>
                                                </td>
                                            	</tr>

                                            </tbody>
                                        </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear">
                            </div>
                        </div>
                    <div class="sectionEditButtons">
                        <button tabindex="27" type="reset" value="reset" id="btnBackupNowCancel" class="stdButton" onclick="cancelEditMode('section_modalContent_0'); return false;" onblur="restartTabbingOrder('frmBackupNow');">
                            <span><fmt:message key="generic.cancel" /></span></button>
                        <button tabindex="26" type="submit" id="btnBackupNow" value="submit" class="stdButton stdButtonEmphasized1">
                            <span><fmt:message key="generic.backup" /></span></button>
                    </div>
                    <input type="hidden" id="backup_domain" name="domain" value="" /><!-- place holder so doesn't break existing ajax call -->
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<script type="text/javascript">
	bindDisableInputsIfDoesNotStartsWith('backup_file_path', "\\\\", ['backup_username', 'backup_password']);
	initBackupNowModalElements();
</script>
