<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>

<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn">
            <h2>
                Register a New vCenter</h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div class="sectionMessages" id="section_modalContent_0_messages">
                    </div>
                    <form id="frmRegister" onsubmit="applyEditMode('section_modalContent_0', registerVCenter()); return false;" enctype="multipart/form-data"
                    method="post">
                        <div class="sectionContent">
                            <div class="contentBlockGroup">
                                <div class="contentBlock" id="block_section_9_1_0_0">
                                    <div class="subTitleBorderBottom">
                                        <span>vCenter Name</span>
                                    </div>
                                    <table class="dataFields" style="margin-bottom:15px;">
                                        <tbody>
                                            <tr class="dataFieldRow">
                                                <td class="fldDescription">
                                                    <span>vCenter Server IP or Hostname</span>
                                                </td>
                                                <td class="fldValue">
                                                    <input type="text" value="" onblur="toggleHighlightRow('machineip');" onfocus="toggleHighlightRow('machineip');"
                                                        size="28" style="width: 14em;" name="machineip" id="machineip" class="inputFldText" />
                                                </td>
                                            </tr>
                                            <tr class="dataFieldRow">
                                                <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                    <span>Description (optional)</span>
                                                </td>
                                                <td class="fldValue">
                                                    <textarea rows="3" style="width:14em;" name="machinedescription" id="machinename" class="inputFldText" onblur="toggleHighlightRow('machinename');" onfocus="toggleHighlightRow('machinename');"></textarea>
                                                    <!--<input type="text" value="" onblur="toggleHighlightRow('machinename');" onfocus="toggleHighlightRow('machinename');"
                                                        size="28" style="width: 14em;" name="machinename" id="machinename" class="inputFldText" />-->
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>

                                    <div class="subTitleBorderBottom">
                                        <span>Admin User Account</span>
                                    </div>
                                    <table class="dataFields">
                                        <tbody>
                                            <tr class="dataFieldRow">
                                                <td class="fldDescription">
                                                    <span>Admin User Name</span>
                                                </td>
                                                <td class="fldValue">
                                                    <input type="text" value="" onblur="toggleHighlightRow('username');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('username');"
                                                        size="28" style="width: 14em;" name="username" id="username" class="inputFldText" rel="notempty" />
                                                </td>
                                            </tr>
                                            <tr class="dataFieldRow">
                                                <td class="fldDescription">
                                                    <span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Password</span>
                                                </td>
                                                <td class="fldValue">
                                                    <input type="password" value="" onblur="toggleHighlightRow('password');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('password');"
                                                        size="28" style="width: 14em;" name="password" id="password" class="inputFldText" rel="notempty" />
                                                </td>
                                            </tr>
                                            <tr class="dataFieldRow">
                                                <td class="fldDescription">
                                                    <span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Verify Password</span>
                                                </td>
                                                <td class="fldValue">
                                                    <input type="password" value="" onblur="toggleHighlightRow('vpassword');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('vpassword');"
                                                        size="28" style="width: 14em;" name="vpassword" id="vpassword" class="inputFldText" rel="notempty" />
                                                </td>
                                            </tr>
                                            <tr class="dataFieldRow">
                                                <td colspan="2" class="fldValue" style="text-align: left">&nbsp;<br />
                                                    <span style="font-weight: bold">Note:</span> The Admin User account is used by the plug-in for vCenter operations.</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear">
                            </div>
                        </div>
                    <div class="sectionEditButtons">
                        <button class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                            <span>Apply</span></button>
                        <button onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton"
                            value="reset" type="reset">
                            <span>Cancel</span></button>
                    </div>
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>

<script type="text/javascript">
    formUtils.setupWatermarks('frmRegister');
</script>
