<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_modalContent_0" class="containerSection defaultShowEditModeOn" style="padding-bottom:0;">
            <h2><fmt:message key="generateCertificateSigningRequest.title" /></h2>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    
                    <div id="view-1" class="swap-area" style="display:block;">
                        <p class="generateCSRModalText"><fmt:message key="generateCertificateSigningRequest.generalInfo" /></p>
                        <div class="statusLargeIcon statusLargeInfoIcon"></div>
                        <p style="margin-top:3px;"><br></br><fmt:message key="generateCertificateSigningRequest.requestConfirmation" /></p>
                        <div class="sectionEditButtons" style="margin:10px;">
                            <button onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.cancel" /></span></button>
                            <button class="stdButton stdButtonEmphasized1" type="button" onclick="showHide('view-2','view-1');">
                                <span><fmt:message key="generic.continue" /></span></button>
                        </div>
                    </div>
                    
                    <div id="view-2" class="swap-area">
                        <div id="section_2_0_messages" class="sectionMessages">
                            <div id="msgBox_section_2_0_0" class="msgBox msgInfo">
                                <div class="msgIcon">
                                </div>
                                <div class="msgContent">
                                    <table class="msgTable">
                                        <tr>
                                            <td>
                                                <div class="msgTitle">
                                                    <fmt:message key="generic.information" /></div>
                                            </td>
                                            <td class="maxWidthCol">
                                                <div id="msgText_section_2_0_0" class="msgText">
                                                    <fmt:message key="generateCertificateSigningRequest.formInstructions" />
                                                </div>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <!--formHandler.send('frmGenerateCSR',urlConfig.generateCSR,
                            {
                                msgArea:'section_2_0_messages',
                                onSuccess:function(responseObj){
                                    var selector = $('update_status'),
                                        checkbox = document.createElement('div'); // checkbox icon, not a form checkbox

                                    selector.innerHTML = responseObj.errorMessage;
                                    checkbox.setAttribute('class','statusLargeIcon statusLargeSuccessIcon');
                                    Element.replace( $('update_status_icon'), checkbox);
                                }
                            }
                        );-->
						<fmt:message key="generateCertificateSigningRequest.CSRSuccess"      var="csrSuccess"/>
                        <fmt:message key="generateCertificateSigningRequest.CSRDownload"     var="csrDownload"/>                        
                        <fmt:message key="generateCertificateSigningRequest.CSRDownloadLink" var="csrDownloadLink"/>
                        
                        <script type="text/javascript">
	                    	loadSortedCountryList();
                        
                        	opts = {
                        		cancelDefaultMessage: true,
	                    		onStart: function () { showHide('view-3', 'view-2'); },
                        		onSuccess: function (responseObj) {
                        			var selector = $('update_status'),
                                        checkImg = new Image();
                        			checkImg.src = 'images/icons/icn_check_lg.png';
                        			checkImg.setAttribute('id', 'update_status_icon');
                        			  
                        			var closeBtn = "<a href=\"" + responseObj.errorMessage + "\" class=\"stdButton stdButtonEmphasized1\"  target=_blank><span>Download</span></a>";
                        			var downloadText = "<a class=\"modalIconLink\" target='_blank' href=\"" + responseObj.errorMessage + "\">${csrDownloadLink}</a>";
                        			var text = '<p>${csrSuccess}</p><p>'+ "${csrDownload}" +'</p><p>' + downloadText + '</p>';
                        			//var text = '<p>Certificate Signing Request has been successfully generated.</p><p>You must download the certificate to be able to use it.</p><p>' + downloadText + '</p>';
                        			
                        			selector.innerHTML = text; //responseObj.errorMessage;
                        			//$('beneath').show();
                        			//$('beneath').innerHTML = downloadText; //'<p style="margin-top:0;padding-top:0;">Certificate Signing Request File &nbsp;&nbsp;'+closeBtn+'</p>';
                        			//$('btn-retry').hide();
	                    			Element.replace($('update_status_icon'), checkImg);
                        		},
                        		onError: function (responseObj) {
                        			var selector = $('update_status'),
                                        checkImg = new Image();
                        			checkImg.src = 'images/icons/icn_fail_lg.png';
                        			checkImg.setAttribute('id', 'update_status_icon');
                        			selector.innerHTML = responseObj.errorMessage;
                        			Element.replace($('update_status_icon'), checkImg);
                        			$('beneath').hide();
                        			//$('btn-retry').show();
                        		}
                        	}
                        </script>
                        <form id="frmGenerateCSR" onsubmit="applyEditMode('section_modalContent_0', formHandler.send(this,urlConfig.generateCSR,opts) );return false;" enctype="multipart/form-data" method="post">
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_9_1_0_0">
                                        <table class="dataFields" style="margin-bottom:15px;">
                                            <tbody>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span><fmt:message key="generateCertificateSigningRequest.commonName" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="1" data-validate="notempty" data-validate-display="applianceManagement.generateCertificateSigningRequest.commonName" type="text" value="" onblur="toggleHighlightRow('commonName');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('commonName');"
                                                            size="28" style="width:14em;" name="commonName" id="commonName" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generateCertificateSigningRequest.organizationName" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="2" data-validate="notempty" data-validate-display="applianceManagement.generateCertificateSigningRequest.organizationalName" type="text" value="" onblur="toggleHighlightRow('orgName');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('orgName');"
                                                            size="28" style="width:14em;" name="orgName" id="orgName" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generateCertificateSigningRequest.organizationalUnit" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="3" data-validate="notempty" data-validate-display="applianceManagement.generateCertificateSigningRequest.organizationalUnit" type="text" value="" onblur="toggleHighlightRow('orgUnit');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('orgUnit');"
                                                            size="28" style="width:14em;" name="orgUnit" id="orgUnit" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generic.locality" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="4" data-validate="notempty" data-validate-display="generic.locality" type="text" value="" onblur="toggleHighlightRow('locality');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('locality');"
                                                            size="28" style="width:14em;" name="locality" id="locality" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generateCertificateSigningRequest.stateName" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="5" data-validate="notempty" data-validate-display="generic.state" type="text" value="" onblur="toggleHighlightRow('state');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('state');"
                                                            size="28" style="width:14em;" name="state" id="state" class="inputFldText" />
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generic.country" /></span>
                                                    </td>
                                                    <td>
                                                        <select tabindex="6" id="country" data-validate-display="generic.country" name="country" style="width:15em; text-transform: uppercase;"></select>


                                                        <script type="text/javascript">
                                                            $$('#country option').each(function(elmnt){
                                                                var text = elmnt.innerHTML;
                                                                if(text.length > 19){
                                                                    elmnt.innerHTML = text.substring(0,19)+'...';
                                                                }
                                                            })
                                                        </script>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription" style="vertical-align:top;background-position:100% 16px;">
                                                        <span><fmt:message key="generic.email" /></span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input tabindex="7" data-validate="notempty" data-validate-display="generic.email" type="text" value="" onblur="toggleHighlightRow('email');" onfocus="formUtils.clearWatermarks(this);toggleHighlightRow('email');"
                                                            size="28" style="width:14em;" name="email" id="email" class="inputFldText" />
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                    <div class="clear">
                                    </div>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                        <div class="sectionEditButtons">
                            <button tabindex="9" onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton" onblur="restartTabbingOrder('frmGenerateCSR');"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.cancel" /></span></button>
                            <button tabindex="8" id="btnSend" class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                                <span><fmt:message key="generic.continue" /></span></button>
                        </div>
                        </form>
                    </div>

                    <script type="text/javascript">
                        $('country').observe('click',function(){
                            this.addClassName('wide');
                        })
                    </script>

                    <div id="view-3" class="swap-area">
                        <div style="float:left;margin:15px 5px 15px 0px;">
                            <img id="update_status_icon" src="images/loading_icon.gif" alt="" />
                        </div>
                        <div id="update_status" style="float:left;margin:20px 0 0;width:270px;"><!-- status msg --></div>
                        <div style="clear:both;"></div>
                        <div id="beneath" style="display:block;text-align:right;"></div>
                        <input type="hidden" id="machineid" name="machineId" value="" />
                        <input type="hidden" id="machinename" name="machineName" />
                        <input type="hidden" id="machineip" name="machineIp" />
                        <div class="sectionEditButtons" style="margin-top:0;">
                            <button onclick="cancelEditMode('section_modalContent_0'); return false;" class="stdButton"
                                value="reset" type="reset">
                                <span><fmt:message key="generic.close" /></span>
                            </button>
                            
                            <!-- <button id="btn-retry" class="stdButton stdButtonEmphasized1" onclick="$('btnSend').click()" style="display:none;"> <span><fmt:message key="generic.retry" /></span> </button> -->
                            
                        </div>
                    </div>
                    
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>

<script type="text/javascript">
   formUtils.setupWatermarks('frmGenerateCSR');
</script>


