<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>

<script type="text/javascript">
    if (VCenter.selectedVCenter != null) {
        $('machineid').value = VCenter.selectedVCenter.machineId.toString();
        $('machinename').value = VCenter.selectedVCenter.machineName;
        $('machineip').value = VCenter.selectedVCenter.machineIp;
        $('username').value = VCenter.selectedVCenter.userName;
        $('password').value = '';
        $('vpassword').value = '';
    }
</script>
<!-- start : container (id #modalContent) -->
<!-- 
			notes:
					- include minMaxButton div within containerCenter if container can be minimized
					
					- special containerTab classes:
							containerWithTabs 	- container uses top aligned tabs
							
							twoSections/threeSections 	- container contains two/three sections - this sets up minimized titles positioning
							
							containerAlerts 	- alerts container - requires special containerCenter spacing
		-->
<div id="container_modalContent" class="container modalAutoCloseOnApplyOrCancel">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <!-- start : container sections content blocks -->
        <!-- start : section (id #section_modalContent_0) -->
        <!-- 
					notes:
							- always includes:
								- sectionEditButtons block
								- sectionMessages block
							
							- optional includes:
								- sectionEditButton block
								- sectionMenu block
							
							- special containerSection classes:
									tableRowExpandedViewSection - section contained within table expanded row
																- uses different spacing for many elements ie. menu, messages, inner content
																- does not include another <form> tag 
									
									defaultShowEditModeOn 	- defaults the section to be in edit ie. edit buttons are visible
				-->
        <div id="section_modalContent_2" class="containerSection defaultShowEditModeOn">
            <h2>
                Test Credentials</h2>
            <!-- start : section container -->
            <!-- 
						notes:
								- used to wrap section content in round orange border when in edit mode
					-->
                
                <div class="sectionContainer">
                    <div class="sectionTop">
                    </div>
                    <div class="sectionCenter">
                        <!-- start : section message block -->
                        <!-- 
							notes:
									- always available to contain and display messages
						-->
                        <div class="sectionMessages" id="section_modalContent_2_messages">
                            <!-- msg boxes inserted here -->
                        </div>
                        <!-- end : section message block -->
                        <!-- start : section form -->
                        <!-- 
								notes:
										- each section has only one form wrapping the entire section content
							-->
                        <form onsubmit="applyEditMode('section_modalContent_2', testVCenter); return false;" enctype="multipart/form-data"
                        method="post" action="#">
                        <!-- start : section content container -->
                        <!-- 
								notes:
										- used to wrap scrollable content area
							-->
                        <div class="sectionContentContainer">
                            <!-- start : section content -->
                            <!-- 
									notes:
											- scrollable content area
								-->
                            <div class="sectionContent">
                                <div class="contentBlockGroup">
                                    <div class="contentBlock" id="block_section_2_0_0_0">
                                        <table class="dataFields" style="position: relative; top: -12px">
                                            <tbody>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription"></td>
                                                    <td class="fldDescription"></td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span>vCenter Server IP or Hostname</span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input type="hidden" name="machineid" id="machineid" value="" />
                                                        <input type="text" value="" onblur="toggleHighlightRow('machineip');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('machineip');"
                                                            size="28" style="width: 14em;" name="machineip" id="machineip" class="inputFldText" disabled/>
                                                    </td>
                                                </tr>
											    <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span>Description (optional)</span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input type="text" value="" onblur="toggleHighlightRow('machinename');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('machinename');"
                                                            size="28" style="width: 14em;" name="machinename" id="machinename" class="inputFldText" disabled/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span>User Name</span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input type="text" value="" onblur="toggleHighlightRow('username');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('username');"
                                                            size="28" style="width: 14em;" name="username" id="username" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span>Password</span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input type="password" value="test" onblur="toggleHighlightRow('password');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('password');"
                                                            size="28" style="width: 14em;" name="password" id="password" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td class="fldDescription">
                                                        <span>Verify Password</span>
                                                    </td>
                                                    <td class="fldValue">
                                                        <input type="password" value="test" onblur="toggleHighlightRow('vpassword');" onfocus="clearIfHelpText(this, 'null'); toggleHighlightRow('vpassword');"
                                                            size="28" style="width: 14em;" name="vpassword" id="vpassword" class="inputFldText"/>
                                                    </td>
                                                </tr>
                                                <tr class="dataFieldRow">
                                                    <td colspan="2" class="fldValue" style="text-align: left">&nbsp;<br />
                                                        <span style="font-weight: bold">Note:</span> The Admin User account is used by the plug-in for vCenter operations.</td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <!-- end : data fields table -->
                                    </div>
                                    
                                    <div class="clear">
                                    </div>
                                </div>
                                <!-- end : content block group -->
                                <div class="clear">
                                </div>
                            </div>
                            <!-- end : section content -->
                        </div>
                        <!-- end : section content container -->
                        <!-- start : section edit buttons -->
                        <div class="sectionEditButtons">
                            <button class="stdButton stdButtonEmphasized1" value="submit" type="submit">
                                <span>Apply</span></button>
                            <button onclick="cancelEditMode('section_modalContent_2'); return false;" class="stdButton"
                                value="reset" type="reset">
                                <span>Cancel</span></button>
                        </div>
                        <!-- end : section edit buttons -->
                        </form>
                        <!-- end : section form -->
                    </div>
                    <div class="sectionBottom">
                    </div>
                </div>
                <!-- end : section container -->
            </div>
            
            
        <!-- end : section (id #section_modalContent_0) -->
        <!-- end : container sections content blocks -->
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<!-- end : container (id #modalContent) -->
