<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<script type="text/javascript">
	onLoadAlertsPage();
</script>

<h1 id="pagetitle">
    <fmt:message key="alertManagement.title" /></h1>
<div id="container_4" class="container">
    <div class="containerTop">
    </div>
    <div class="containerCenter">
        <div id="section_4_0" class="containerSection minContainerHeight">
            <h2><fmt:message key="alertManagement.alertsDatabaseTitle" /></h2>
            <div class="sectionEditButton" onclick="editButtonClickForSimpleForm('section_4_0', 'block_section_4_0_0_1');">
                <div class="sectionEditButtonInner">
                    <fmt:message key="generic.edit" /></div>
            </div>
            <div class="sectionContainer">
                <div class="sectionTop">
                </div>
                <div class="sectionCenter">
                    <div id="section_4_0_messages" class="sectionMessages">
                        <div id="msgBox_section_4_0_0" class="msgBox msgInfo">
                            <div class="msgIcon">
                            </div>
                            <div class="msgContent">
                                <table class="msgTable">
                                    <tr>
                                        <td>
                                            <div class="msgTitle">
                                                <fmt:message key="generic.information" /></div>
                                        </td>
                                        <td class="maxWidthCol">
                                            <div id="msgText_section_4_0_0" class="msgText">
                                                <fmt:message key="alertManagement.messages.instructions" />
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>
                    <form id="frmAlert" method="post" enctype="multipart/form-data" onsubmit="applyEditModeForSimpleForm('section_4_0', setAlert); return false;">
                    <div class="sectionContentContainer">
                        <div class="sectionContent">
                            <div class="contentBlockGroup">
                                <div id="block_section_4_0_0_1" class="contentBlock">
                                    <table class="dataFields">
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="alertManagement.currentNumberOfAlerts" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span id="number_of_alerts"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="alertManagement.maximumNumberOfAlerts" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="1" id="max_of_alerts" class="inputFldText" size="20" helptext="<fmt:message key="generic.notConfigured" />"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="alertManagement.numberOfDaysToRetainAlerts" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="2" id="days_to_retain" class="inputFldText" size="20" helptext="<fmt:message key="generic.notConfigured" />"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                        <tr class="dataFieldRow">
                                            <td class="fldDescription">
                                                <span><fmt:message key="alertManagement.timeoutForDuplicateAlerts" /></span>
                                            </td>
                                            <td class="fldValue">
                                                <span tabindex="3" id="timeout_for_duplicates" class="inputFldText" size="20" helptext="<fmt:message key="generic.notConfigured" />"><fmt:message key="generic.loading" />...</span>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                                <div class="clear">
                                </div>
                            </div>
                            <div class="clear">
                            </div>
                        </div>
                    </div>
                    <div class="sectionEditButtons">
                        <button tabindex="5" type="reset" value="reset" class="stdButton" onclick="cancelEditMode('section_4_0'); return false;" onblur="restartTabbingOrder('frmAlert');">
                            <span><fmt:message key="generic.cancel" /></span></button>
                        <button tabindex="4" type="submit" value="submit" class="stdButton stdButtonEmphasized1">
                            <span><fmt:message key="generic.apply" /></span></button>
                    </div>
                    </form>
                </div>
                <div class="sectionBottom">
                </div>
            </div>
        </div>
        <div class="clear">
        </div>
    </div>
    <div class="containerBottom">
    </div>
</div>
<!-- end : container (id #4) -->
