﻿var postLogin = {
    timer: null,
    posted: null,
    post: function () {
        //turn on verify
        $('loginContainer').addClassName('loginVerify');
        //post the form
        new Ajax.Request(urlConfig.loginPost, {
            method: urlConfig.postMethod,
            parameters: $('loginForm').serialize(true),
            onSuccess: function (transport) { postLogin.success(transport.responseText) }
        });
        postLogin.posted = true;
        return false;
    },
    success: function (obj) {
        //check if post was cancelled
        if (postLogin.posted == true) {
            postLogin.posted == false;
            //check responseCode and send to url if 0
            var LoginResponse = obj.evalJSON(true);
            if (LoginResponse.responseCode == 0) {
                document.location.href = LoginResponse.URL;
            } else {
                postLogin.failed(LoginResponse);
            }
        }
    },
    failed: function (obj) {
        //fill in error title and message with response
        $('loginErrorTitle').innerHTML = obj.responseTitle;
        $('loginErrorMessage').innerHTML = obj.responseMessage;
        //turn off verify
        $('loginContainer').removeClassName('loginVerify');
        //turn on failed
        $('loginContainer').addClassName('loginError');
        //add timer for calling tryagain after 15 seconds or so
        postLogin.timer = postLogin.tryAgain.delay(15);
    },
    tryAgain: function () {
        $('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
        return false;
    },
    cancel: function () {
        //clear fields
        $('loginContainer').removeClassName('loginVerify');
        $('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
        postLogin.posted = false;
    }
};
var postLogout = {
    post: function () {
        new Ajax.Request(urlConfig.logoutPost, {
            method: urlConfig.postMethod,
            onSuccess: function (transport) { postLogout.success(transport.responseText) }
        });
        return false;
    },
    success: function (obj) {
        var LogoutResponse = obj.evalJSON(true);
        if (LogoutResponse.responseCode == 0) {
            document.location.href = LogoutResponse.URL;
        } else {
            postLogout.failed(LogoutResponse);
        }
    },
    failed: function (obj) {
        //not sure what to do if this fails
    }
};