﻿

if (typeof document.observe == 'function') {
    
    
    document.observe("dom:loaded", function () {
        
        // load the navigation
        navigationConfigLoader.initialize();
        
        // initialize the history object found in prototypeextensions.js
        History.Observer.start();
        History.Observer.delay = 0.5;
        History.Registry.set(navigation, function (value) { navigation.onStateChange(value) });
    
    });
    
    
    Event.observe(window, 'load', function () {
        
        // default load first item in navigation
        setTimeout(function () {
				navigation.clickFirst();
			}, 300);

        // set on click event on entire main div to determine if drop down needs to close
        $('main').observe('click', function (event) {
            var element = event.element();
            // check to see if clicking on drop down
            if (!element.up('.dropDown')) {
                // close all drop downs
                $$('.dropDown.opened').each(function (item) { closeDropDown(item.id); });
            }
        });
    });
    
    // on window resize functions
    Event.observe(window, 'resize', function () {
        
        // if modal window open, redo dimensions
        if ($('modalOverlay') && $('modalOverlay').visible()) {
            setModalContentDimensions();
        }
        
    });
};

